// LayerView.cpp : CLayerView NX̎
//

#include "stdafx.h"
#include "Layer.h"

#include "LayerDoc.h"
#include "LayerView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "MainFrm.h"
extern CMainFrame* g_pMainFrame;
#include "DlgOption.h"
#include <float.h>

// CLayerView

IMPLEMENT_DYNCREATE(CLayerView, CView)

BEGIN_MESSAGE_MAP(CLayerView, CView)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_WM_KEYDOWN()
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_MIYA, OnUpdateIndicatorMiya)
	ON_UPDATE_COMMAND_UI(ID_VIEW_COLOR, &CLayerView::OnUpdateViewColor)
	ON_COMMAND(ID_VIEW_COLOR, &CLayerView::OnViewColor)
	ON_COMMAND(ID_VIEW_INPUT, &CLayerView::OnViewInput)
	ON_COMMAND(ID_VIEW_VALIDPIXEL, &CLayerView::OnViewValidpixel)
	ON_COMMAND(ID_VIEW_PSEUDOZENITH, &CLayerView::OnViewPseudozenith)
	ON_COMMAND(ID_VIEW_PSEUDOAZIMUTH, &CLayerView::OnViewPseudoazimuth)
	ON_COMMAND(ID_VIEW_PSEUDONEEDLE, &CLayerView::OnViewPseudoneedle)
	ON_COMMAND(ID_VIEW_IDEAL, &CLayerView::OnViewIdeal)
	ON_COMMAND(ID_VIEW_MEAN, &CLayerView::OnViewMean)
	ON_COMMAND(ID_VIEW_REGION, &CLayerView::OnViewRegion)
	ON_COMMAND(ID_VIEW_ALBEDO, &CLayerView::OnViewAlbedo)
	ON_COMMAND(ID_VIEW_ZENITHCONSTRAINT, &CLayerView::OnViewZenithconstraint)
	ON_COMMAND(ID_VIEW_AZIMUTHCONSTRAINT, &CLayerView::OnViewAzimuthconstraint)
	ON_COMMAND(ID_VIEW_NEEDLECONSTRAINT, &CLayerView::OnViewNeedleconstraint)
	ON_COMMAND(ID_VIEW_INSIDE, &CLayerView::OnViewInside)
	ON_COMMAND(ID_VIEW_ZENITHBOUNDARY, &CLayerView::OnViewZenithboundary)
	ON_COMMAND(ID_VIEW_AZIMUTHBOUNDARY, &CLayerView::OnViewAzimuthboundary)
	ON_COMMAND(ID_VIEW_NEEDLEBOUNDARY, &CLayerView::OnViewNeedleboundary)
	ON_COMMAND(ID_VIEW_ZENITHCOORD, &CLayerView::OnViewZenithcoord)
	ON_COMMAND(ID_VIEW_AZIMUTHCOORD, &CLayerView::OnViewAzimuthcoord)
	ON_COMMAND(ID_VIEW_NEEDLECOORD, &CLayerView::OnViewNeedlecoord)
	ON_COMMAND(ID_CALC_SVD, &CLayerView::OnCalcSvd)
	ON_COMMAND(ID_CALC_REGION, &CLayerView::OnCalcRegion)
	ON_COMMAND(ID_CALC_CONSTRAINT, &CLayerView::OnCalcConstraint)
	ON_COMMAND(ID_CALC_BOUNDARY, &CLayerView::OnCalcBoundary)
	ON_COMMAND(ID_CALC_ROTATION, &CLayerView::OnCalcRotation)
	ON_COMMAND(ID_OPTION_OPTION, &CLayerView::OnOptionOption)
	ON_COMMAND(ID_CALC_INIT, &CLayerView::OnCalcInit)
	ON_COMMAND(ID_VIEW_BASIS1, &CLayerView::OnViewBasis1)
	ON_COMMAND(ID_VIEW_BASIS2, &CLayerView::OnViewBasis2)
	ON_COMMAND(ID_VIEW_BASIS3, &CLayerView::OnViewBasis3)
	ON_COMMAND(ID_CALC_OPTIMIZE, &CLayerView::OnCalcOptimize)
	ON_COMMAND(ID_VIEW_SHADOWINIT, &CLayerView::OnViewShadowinit)
	ON_COMMAND(ID_VIEW_SPECULARINIT, &CLayerView::OnViewSpecularinit)
	ON_COMMAND(ID_VIEW_SHADOWOPT, &CLayerView::OnViewShadowopt)
	ON_COMMAND(ID_VIEW_SPECULAROPT, &CLayerView::OnViewSpecularopt)
	ON_COMMAND(ID_CALC_TRICOLOR, &CLayerView::OnCalcTricolor)
	ON_COMMAND(ID_VIEW_TRICOLOR, &CLayerView::OnViewTricolor)
END_MESSAGE_MAP()

// CLayerView RXgNV/fXgNV

CLayerView::CLayerView()
{
	int i;
	int x, y;
	int c;
	int p;

	// z̃TCYݒ
	PROCESSMAX = 100;
	WIDTH = 640;
	HEIGHT = 480;
	PIXELNUM = WIDTH * HEIGHT;
	IMAGEMIN = 6;
	IMAGEMAX = 100;

	// vO}̃~X`FbN
	if(WIDTH % 4 != 0) AfxMessageBox("WIDTH4̔{ɂĂ");
	if(IMAGEMIN < 6) AfxMessageBox("IMAGEMIN6ȏɂĂ");
	if(IMAGEMIN > IMAGEMAX) AfxMessageBox("IMAGEMAXIMAGEMINȏɂĂ");

	// z̃m
	try
	{
		processdone = new bool[PROCESSMAX];
		needleimage = new unsigned char**[WIDTH];
		idealimage = new unsigned char**[WIDTH];
		inputimage = new unsigned char[IMAGEMAX * WIDTH * HEIGHT * 3];
		screendata = new unsigned char[4 * WIDTH * HEIGHT];
		pseudonormal = new double**[WIDTH];
		pseudoalbedo = new double**[WIDTH];
		normalconstraint = new double**[WIDTH];
		albedo = new double**[WIDTH];
		inside = new unsigned char*[WIDTH];
		normalboundary = new double**[WIDTH];
		coordnormal = new double**[WIDTH];
		mats = new double*[PIXELNUM];
		matl = new double*[3];
		eigens = new double*[PIXELNUM];
		eigenl = new double*[3];
		conss = new double*[PIXELNUM];
		consl = new double*[3];
		coordl = new double*[3];
		validpixel = new bool*[WIDTH];
		medianimage = new unsigned char**[WIDTH];
		region = new bool*[WIDTH];
		shadowinit = new bool[IMAGEMAX * WIDTH * HEIGHT];
		specularinit = new bool[IMAGEMAX * WIDTH * HEIGHT];
		shadowopt = new bool[IMAGEMAX * WIDTH * HEIGHT];
		specularopt = new bool[IMAGEMAX * WIDTH * HEIGHT];
		idealfloat = new float[IMAGEMAX * WIDTH * HEIGHT];
		tricolor = new unsigned char[WIDTH * HEIGHT * 3];
	}
	catch(...)
	{
		AfxMessageBox("܂");
		return;
	}
	for(x = 0; x < WIDTH; x++)
	{
		try
		{
			pseudonormal[x] = new double*[HEIGHT];
			pseudoalbedo[x] = new double*[HEIGHT];
			normalconstraint[x] = new double*[HEIGHT];
			albedo[x] = new double*[HEIGHT];
			needleimage[x] = new unsigned char*[HEIGHT];
			idealimage[x] = new unsigned char*[HEIGHT];
			inside[x] = new unsigned char[HEIGHT];
			normalboundary[x] = new double*[HEIGHT];
			coordnormal[x] = new double*[HEIGHT];
			validpixel[x] = new bool[HEIGHT];
			medianimage[x] = new unsigned char*[HEIGHT];
			region[x] = new bool[HEIGHT];
		}
		catch(...)
		{
			AfxMessageBox("܂");
			return;
		}
		for(y = 0; y < HEIGHT; y++)
		{
			try
			{
				pseudonormal[x][y] = new double[3];
				pseudoalbedo[x][y] = new double[3];
				normalconstraint[x][y] = new double[3];
				albedo[x][y] = new double[3];
				needleimage[x][y] = new unsigned char[3];
				idealimage[x][y] = new unsigned char[3];
				normalboundary[x][y] = new double[3];
				coordnormal[x][y] = new double[3];
				medianimage[x][y] = new unsigned char[3];
			}
			catch(...)
			{
				AfxMessageBox("܂");
				return;
			}
		}
	}
	for(p = 0; p < PIXELNUM; p++)
	{
		try
		{
			mats[p] = new double[3];
			eigens[p] = new double[3];
			conss[p] = new double[3];
		}
		catch(...)
		{
			AfxMessageBox("܂");
			return;
		}
	}
	for(i = 0; i < 3; i++)
	{
		try
		{
			matl[i] = new double[IMAGEMAX];
			eigenl[i] = new double[IMAGEMAX];
			consl[i] = new double[IMAGEMAX];
			coordl[i] = new double[IMAGEMAX];
		}
		catch(...)
		{
			AfxMessageBox("܂");
			return;
		}
	}

	// l
	EPS = 1.0e-15;
	INF = 1.0e+38;
	if(sizeof(int) == 4) INTINF = 0x7fff;
	else {INTINF = 0; AfxMessageBox("int^32bitł͂܂");}
	PI = 3.1415926535897932384626433832795;
	MENUVIEW = 1; // [\]j[j[Ŝ̉Ԗڂ̍ڂ
	COLR = 0;
	COLG = 1;
	COLB = 2;
	AXISX = 0;
	AXISY = 1;
	AXISZ = 2;
	REGIONOUTSIDE = 0;
	REGIONINSIDE = 1;
	REGIONBOUNDARY = 2;
	MIYA_INPUT = 0;
	MIYA_SEP01 = 1;
	MIYA_SHADOWINIT = 2;
	MIYA_SPECULARINIT = 3;
	MIYA_SEP02 = 4;
	MIYA_VALIDPIXEL = 5;
	MIYA_PSEUDOZENITH = 6;
	MIYA_PSEUDOAZIMUTH = 7;
	MIYA_PSEUDONEEDLE = 8;
	MIYA_IDEAL = 9;
	MIYA_SEP03 = 10;
	MIYA_BASIS1 = 11;
	MIYA_BASIS2 = 12;
	MIYA_BASIS3 = 13;
	MIYA_SHADOWOPT = 14;
	MIYA_SPECULAROPT = 15;
	MIYA_SEP04 = 16;
	MIYA_MEDIAN = 17;
	MIYA_REGION = 18;
	MIYA_SEP05 = 19;
	MIYA_ALBEDO = 20;
	MIYA_ZENITHCONSTRAINT = 21;
	MIYA_AZIMUTHCONSTRAINT = 22;
	MIYA_NEEDLECONSTRAINT = 23;
	MIYA_SEP06 = 24;
	MIYA_INSIDE = 25;
	MIYA_ZENITHBOUNDARY = 26;
	MIYA_AZIMUTHBOUNDARY = 27;
	MIYA_NEEDLEBOUNDARY = 28;
	MIYA_SEP07 = 29;
	MIYA_COORDZENITH = 30;
	MIYA_COORDAZIMUTH = 31;
	MIYA_COORDNEEDLE = 32;
	MIYA_SEP08 = 33;
	MIYA_TRICOLOR = 34;
	maxmenu = 35;
	viewmode = 0;
	colormode = true;
	CheckView(0);
	imageview = 0;
	imagenum = 0;
	sFileName = "basis";

	// z
	for(i = 0; i < PROCESSMAX; i++) processdone[i] = false;
	for(i = 0; i < 4 * WIDTH * HEIGHT; i++) screendata[i] = 0;
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			for(c = 0; c < 3; c++)
			{
				needleimage[x][y][c] = 0;
			}
		}
	}

	// Initialize graph
	graph = new GraphType(/*estimated # of nodes*/ WIDTH * HEIGHT,
		/*estimated # of edges*/ (WIDTH - 1) * HEIGHT + (HEIGHT - 1) * WIDTH);
	graph->add_node(HEIGHT * WIDTH);
	for(i = 0; i < (WIDTH - 1) * HEIGHT + (HEIGHT - 1) * WIDTH; i++) graph->add_edge(0, 1, 1.0f, 1.0f);
}

CLayerView::~CLayerView()
{
}

BOOL CLayerView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

// CLayerView `

void CLayerView::OnDraw(CDC* pDC)
{
	CBitmap bitmap;
	CDC dcMemory;
	int w, h;

	if(processdone[viewmode] == false) return;

	// ̂̉摜\
	w = WIDTH;
	h = HEIGHT;
	if(w % 4 > 0){}//??
	bitmap.CreateCompatibleBitmap(pDC, w, h);
	bitmap.SetBitmapBits(w * h * 4, screendata);
	dcMemory.CreateCompatibleDC(pDC);
	dcMemory.SelectObject(&bitmap);
	pDC->BitBlt(0, 0, w, h, &dcMemory, 0, 0, SRCCOPY);
	bitmap.DeleteObject();
	dcMemory.DeleteDC();
}


// CLayerView ff

#ifdef _DEBUG
void CLayerView::AssertValid() const
{
	CView::AssertValid();
}

void CLayerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CLayerDoc* CLayerView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CLayerDoc)));
	return (CLayerDoc*)m_pDocument;
}
#endif //_DEBUG


// CLayerView bZ[W nh

void CLayerView::CheckView(int miyamenu)
{
	g_pMainFrame->GetMenu()->GetSubMenu(MENUVIEW)->CheckMenuRadioItem(0, maxmenu - 1, miyamenu, MF_BYPOSITION);
}

void CLayerView::OnViewInput()
{
	viewmode = MIYA_INPUT;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewShadowinit()
{
	viewmode = MIYA_SHADOWINIT;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewSpecularinit()
{
	viewmode = MIYA_SPECULARINIT;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewValidpixel()
{
	viewmode = MIYA_VALIDPIXEL;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewPseudozenith()
{
	viewmode = MIYA_PSEUDOZENITH;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewPseudoazimuth()
{
	viewmode = MIYA_PSEUDOAZIMUTH;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewPseudoneedle()
{
	viewmode = MIYA_PSEUDONEEDLE;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewIdeal()
{
	viewmode = MIYA_IDEAL;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewBasis1()
{
	viewmode = MIYA_BASIS1;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewBasis2()
{
	viewmode = MIYA_BASIS2;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewBasis3()
{
	viewmode = MIYA_BASIS3;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewShadowopt()
{
	viewmode = MIYA_SHADOWOPT;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewSpecularopt()
{
	viewmode = MIYA_SPECULAROPT;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewMean()
{
	viewmode = MIYA_MEDIAN;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewRegion()
{
	viewmode = MIYA_REGION;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewAlbedo()
{
	viewmode = MIYA_ALBEDO;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewZenithconstraint()
{
	viewmode = MIYA_ZENITHCONSTRAINT;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewAzimuthconstraint()
{
	viewmode = MIYA_AZIMUTHCONSTRAINT;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewNeedleconstraint()
{
	viewmode = MIYA_NEEDLECONSTRAINT;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewInside()
{
	viewmode = MIYA_INSIDE;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewZenithboundary()
{
	viewmode = MIYA_ZENITHBOUNDARY;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewAzimuthboundary()
{
	viewmode = MIYA_AZIMUTHBOUNDARY;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewNeedleboundary()
{
	viewmode = MIYA_NEEDLEBOUNDARY;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewZenithcoord()
{
	viewmode = MIYA_COORDZENITH;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewAzimuthcoord()
{
	viewmode = MIYA_COORDAZIMUTH;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewNeedlecoord()
{
	viewmode = MIYA_COORDNEEDLE;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewTricolor()
{
	viewmode = MIYA_TRICOLOR;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnUpdateViewColor(CCmdUI *pCmdUI)
{
	if(colormode) pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
}

void CLayerView::OnViewColor()
{
	if(colormode) colormode = false;
	else colormode = true;
	CreateImages();
	Invalidate();
}

void CLayerView::OnOptionOption()
{
	AfxMessageBox("̋@\͂܂Ă܂");
}

void CLayerView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if(nChar == VK_UP)
	{
		imageview--;
		if(imageview < 0) imageview = imagenum - 1;
	}
	if(nChar == VK_DOWN)
	{
		imageview++;
		if(imageview > imagenum - 1) imageview = 0;
	}

	CreateImages();
	Invalidate(FALSE);
	UpdateMiyaStatusbar();

	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CLayerView::UpdateMiyaStatusbar(void)
{
	CString s;
	s.Format("% 4d/% 4d", imageview + 1, imagenum);
	g_pMainFrame->m_wndStatusBar.SetPaneText(1, s, TRUE);
}

void CLayerView::OnUpdateIndicatorMiya(CCmdUI *pCmdUI)
{
	pCmdUI->Enable();
}

void CLayerView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	UpdateMiyaStatusbar();
}

// t@CJ
void CLayerView::OnFileOpen()
{
	POSITION pos;
	CFileDialog *cfd;
	CString sFileEach;
	CString sFilter;
	int inx;
	CString str;
	char* ctemp;
	int i;
	int x, y;
	int c;
	int n;
	int j;
	CString sFileHead;

	// ̊m
	try
	{
		ctemp = new char[4096 + 1];
	}
	catch(...)
	{
		AfxMessageBox("܂");
		return;
	}
	ctemp[0] = '\0';

	// f[^
	for(i = 0; i < IMAGEMAX; i++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			for(y = 0; y < HEIGHT; y++)
			{
				for(c = 0; c < 3; c++)
				{
					inputimage[imgarry(i,x,y,c)] = 0;
				}
			}
		}
	}

	// t@CJ
	sFilter.Format("*.%d.%d.uchar.img.lay", WIDTH, HEIGHT);
	cfd = new CFileDialog(true, NULL, NULL,
		OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_ALLOWMULTISELECT | OFN_EXPLORER | OFN_LONGNAMES,
		"ǂݍނׂt@C (" + sFilter + ")|" + sFilter + "|SẴC[t@C (*.lay)|*.lay|SẴt@C (*.*)|*.*||",
		AfxGetApp()->GetMainWnd());
	if(cfd == 0) return;
	cfd->m_ofn.lpstrTitle = "摜t@CJ܂";
	cfd->m_ofn.lpstrFile = ctemp;
	cfd->m_ofn.nMaxFile = 4096;
	sFileHead = "";
	imagenum = 0;
	if(cfd->DoModal() == IDOK)
	{
		pos = cfd->GetStartPosition();
		while(pos != NULL)
		{
			// t@C擾
			sFileEach = cfd->GetNextPathName(pos);

			// gqt@C̎ނo
			inx = sFileEach.ReverseFind('.');
			if(inx == -1) continue;
			if(sFileEach.Mid(inx) == ".lay")
			{
				str = sFileEach.Left(inx);
				inx = str.ReverseFind('.');
				if(inx == -1) continue;
				if(str.Mid(inx) == ".img")
				{
					str = str.Left(inx);
					inx = str.ReverseFind('.');
					if(inx == -1) continue;
					if(str.Mid(inx) == ".uchar")
					{
						str = str.Left(inx);
						inx = str.ReverseFind('.');
						n = atoi(str.Mid(inx + 1));
						if(n == HEIGHT)
						{
							str = str.Left(inx);
							inx = str.ReverseFind('.');
							n = atoi(str.Mid(inx + 1));
							if(n == WIDTH)
							{
								// Y
								if(imagenum == IMAGEMAX) imagenum = IMAGEMAX - 1;

								// t@Cǂݍ
								ReadData(sFileEach, imagenum);

								// t@C𒊏o
								if(sFileHead == "") sFileHead = sFileEach;
								else
								{
									inx = sFileEach.ReverseFind('\\');
									sFileEach = sFileEach.Mid(inx + 1);
									if(sFileEach != "")
									{
										for(j = 0; j < sFileHead.GetLength(); j++)
										{
											if(j >= sFileEach.GetLength()) break;
											if(sFileHead[j] != sFileEach[j]) break;
										}
										sFileHead = sFileHead.Left(j);
									}
								}

								// Y
								imagenum++;
							}
						}
					}
				}
			}
		}
	}
	delete cfd;

	// t@Cݒ
	if(sFileHead != "") sFileName = sFileHead;
	if(sFileName.Right(1) == ".") sFileName = sFileName.Left(sFileName.GetLength() - 1);

	// ㏈
	processdone[MIYA_INPUT] = true;
	CreateImages();
	Invalidate();
	UpdateMiyaStatusbar();

	// 
	delete [] ctemp;
}

// f[^t@Cǂݍ
void CLayerView::ReadData(CString filename, int id)
{
	CWaitCursor wait;
	CFile cf(filename, CFile::modeRead);
	CArchive ar(&cf, CArchive::load);
	int x, y;
	int c;

	// f[^ǂݍ
	for(y = 0; y < HEIGHT; y++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			for(c = 0; c < 3; c++)
			{
				ar >> inputimage[imgarry(id,x,y,c)];
			}
		}
	}

	ar.Close();
	cf.Close();
}

// t@Cۑ
void CLayerView::OnFileSaveAs()
{
	CWinApp* theApp = AfxGetApp();
	CFileDialog *cfd;
	CString s;
	int c;
	bool colormodebackup;
	int viewmodebackup;
	int imageviewbackup;
	CString sc;
	int i;

	colormodebackup = colormode;
	viewmodebackup = viewmode;
	imageviewbackup = imageview;

	for(c = 0; c < 2; c++)
	{
		if(c == 0)
		{
			colormode = true;
			sc = "color";
		}
		else
		{
			colormode = false;
			sc = "gray";
		}

		if(colormode == false)
		{
			cfd = new CFileDialog(FALSE, "bmp", sFileName + "-validpixel-" + sc + ".bmp",
				OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
				"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
			cfd->m_ofn.lpstrTitle = "Lȉft@Cۑ܂";
			if(cfd->DoModal() == IDOK)
			{
				viewmode = MIYA_VALIDPIXEL;
				CreateImages();
				WriteImage(cfd->GetPathName());
			}
			delete cfd;
		}

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-pseudozenith-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "[VpƉ摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_PSEUDOZENITH;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-pseudoazimuth-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "[ʊpӉ摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_PSEUDOAZIMUTH;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		if(colormode == false)
		{
			cfd = new CFileDialog(FALSE, "bmp", sFileName + "-pseudoneedle-" + sc + ".bmp",
				OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
				"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
			cfd->m_ofn.lpstrTitle = "[j[h}bv摜t@Cۑ܂";
			if(cfd->DoModal() == IDOK)
			{
				viewmode = MIYA_PSEUDONEEDLE;
				CreateImages();
				WriteImage(cfd->GetPathName());
			}
			delete cfd;
		}

		if(colormode == false)
		{
			cfd = new CFileDialog(FALSE, "bmp", sFileName + "-region-" + sc + ".bmp",
				OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
				"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
			cfd->m_ofn.lpstrTitle = "F̈敪摜t@Cۑ܂";
			if(cfd->DoModal() == IDOK)
			{
				viewmode = MIYA_REGION;
				CreateImages();
				WriteImage(cfd->GetPathName());
			}
			delete cfd;
		}

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-basis1-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "P摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_BASIS1;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-basis2-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "Q摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_BASIS2;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-basis3-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "R摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_BASIS3;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		if(colormode == true)
		{
			cfd = new CFileDialog(FALSE, "bmp", sFileName + "-albedo-" + sc + ".bmp",
				OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
				"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
			cfd->m_ofn.lpstrTitle = "Axh摜t@Cۑ܂";
			if(cfd->DoModal() == IDOK)
			{
				viewmode = MIYA_ALBEDO;
				CreateImages();
				WriteImage(cfd->GetPathName());
			}
			delete cfd;
		}

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-zenithconstraint-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "ŉVpƉ摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_ZENITHCONSTRAINT;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-azimuthconstraint-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "ŉʊpӉ摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_AZIMUTHCONSTRAINT;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		if(colormode == false)
		{
			cfd = new CFileDialog(FALSE, "bmp", sFileName + "-needleconstraint-" + sc + ".bmp",
				OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
				"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
			cfd->m_ofn.lpstrTitle = "ŉj[h}bv摜t@Cۑ܂";
			if(cfd->DoModal() == IDOK)
			{
				viewmode = MIYA_NEEDLECONSTRAINT;
				CreateImages();
				WriteImage(cfd->GetPathName());
			}
			delete cfd;
		}

		if(colormode == false)
		{
			cfd = new CFileDialog(FALSE, "bmp", sFileName + "-inside-" + sc + ".bmp",
				OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
				"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
			cfd->m_ofn.lpstrTitle = "̗̈摜t@Cۑ܂";
			if(cfd->DoModal() == IDOK)
			{
				viewmode = MIYA_INSIDE;
				CreateImages();
				WriteImage(cfd->GetPathName());
			}
			delete cfd;
		}

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-boundaryzenith-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "ՕE̓VpƉ摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_ZENITHBOUNDARY;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-boundaryazimuth-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "ՕE̕ʊpӉ摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_AZIMUTHBOUNDARY;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		if(colormode == false)
		{
			cfd = new CFileDialog(FALSE, "bmp", sFileName + "-boundaryneedle-" + sc + ".bmp",
				OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
				"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
			cfd->m_ofn.lpstrTitle = "ՕẼj[h}bv摜t@Cۑ܂";
			if(cfd->DoModal() == IDOK)
			{
				viewmode = MIYA_NEEDLEBOUNDARY;
				CreateImages();
				WriteImage(cfd->GetPathName());
			}
			delete cfd;
		}

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-coordzenith-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "Wnł̓VpƉ摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_COORDZENITH;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-coordazimuth-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "Wnł̕ʊpӉ摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_COORDAZIMUTH;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		if(colormode == false)
		{
			cfd = new CFileDialog(FALSE, "bmp", sFileName + "-coordneedle-" + sc + ".bmp",
				OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
				"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
			cfd->m_ofn.lpstrTitle = "Wnł̃j[h}bv摜t@Cۑ܂";
			if(cfd->DoModal() == IDOK)
			{
				viewmode = MIYA_COORDNEEDLE;
				CreateImages();
				WriteImage(cfd->GetPathName());
			}
			delete cfd;
		}
	}

	colormode = true;
	cfd = new CFileDialog(FALSE, "bmp", sFileName + "-finalalbedo.bmp",
		OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
		"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
	cfd->m_ofn.lpstrTitle = "AxhŏIʉ摜t@Cۑ܂";
	if(cfd->DoModal() == IDOK)
	{
		viewmode = MIYA_TRICOLOR;
		CreateImages();
		WriteImage(cfd->GetPathName());
	}
	delete cfd;

	s = sFileName;
	s += "-coord";
	s.AppendFormat(".%d.%d.normal.lay", WIDTH, HEIGHT);
	cfd = new CFileDialog(FALSE, "lay", s,
		OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
		"C[t@C (*.lay)|*.lay|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
	cfd->m_ofn.lpstrTitle = "Wn̐@t@Cۑ܂";
	if(cfd->DoModal() == IDOK) WriteData(cfd->GetPathName(), MIYA_COORDNEEDLE);
	delete cfd;

	s = sFileName;
	s.AppendFormat(".%d.%d.inside.lay", WIDTH, HEIGHT);
	cfd = new CFileDialog(FALSE, "lay", s,
		OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
		"C[t@C (*.lay)|*.lay|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
	cfd->m_ofn.lpstrTitle = "̗̈t@Cۑ܂";
	if(cfd->DoModal() == IDOK) WriteData(cfd->GetPathName(), MIYA_INSIDE);
	delete cfd;

	if(AfxMessageBox("z摜ۑ܂H", MB_YESNO | MB_DEFBUTTON2) == IDYES)
	{
		colormode = true;
		viewmode = MIYA_IDEAL;
		for(i = 0; i < imagenum; i++)
		{
			imageview = i;
			s = sFileName;
			s.AppendFormat("-ideal-%02d.bmp", i);
			cfd = new CFileDialog(FALSE, "bmp", s,
				OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
				"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
			cfd->m_ofn.lpstrTitle = "z摜t@Cۑ܂";
			if(cfd->DoModal() == IDOK)
			{
				CreateImages();
				WriteImage(cfd->GetPathName());
			}
			delete cfd;
		}
	}

	colormode = colormodebackup;
	viewmode = viewmodebackup;
	imageview = imageviewbackup;
}

// BMPt@C
void CLayerView::WriteImage(CString filename)
{
	CWaitCursor wait;
	BITMAPFILEHEADER bmfh;
	BITMAPINFOHEADER bmih;
	int i, j;
	unsigned char* ras;
	int x, y;
	int mx, my;
	unsigned char cr, cg, cb;
	int w, h;
	int k;
	CFile cf(filename, CFile::modeWrite | CFile::modeCreate);
	CArchive ar(&cf, CArchive::store);

	w = WIDTH;
	h = HEIGHT;

	bmfh.bfType = 0x4D42;
	bmfh.bfOffBits = 54;
	bmih.biSize = 40;
	bmih.biBitCount = 24;
	bmih.biWidth = w;
	bmih.biHeight = h;
	bmih.biPlanes = 1;
	bmih.biCompression = BI_RGB;
	bmih.biSizeImage = 0;
	bmih.biXPelsPerMeter = 0;
	bmih.biYPelsPerMeter = 0;
	bmih.biClrUsed = 0;
	bmih.biClrImportant = 0;
	j = w * 3;
	j = ((j + 3) / 4) * 4;
	ras = new unsigned char [j * h];
	for(i = 0; i < j * h; i++) ras[i] = 0;
	for(y = 0; y < h; y++)
	{
		my = h - 1 - y;
		for(x = 0; x < w; x++)
		{
			mx = x * 3;
			i = my * j + mx;
			if(w % 4 == 0) k = y * w * 4 + x * 4;
			else k = y * w * 4 + x * 4;//??
			cb = screendata[k + 0];
			cg = screendata[k + 1];
			cr = screendata[k + 2];
			ras[i + 0] = cb;
			ras[i + 1] = cg;
			ras[i + 2] = cr;;
		}
	}
	bmfh.bfSize = 54 + j * h;
	ar.Write((void*)&bmfh, 14);
	ar.Write((void*)&bmih, 40);
	ar.Write(ras, j * h);
	delete ras;

	ar.Close();
	cf.Close();
}

// f[^t@C
void CLayerView::WriteData(CString filename, int filemode)
{
	CWaitCursor wait;
	CFile cf(filename, CFile::modeWrite | CFile::modeCreate);
	CArchive ar(&cf, CArchive::store);
	int x, y;
	int c;

	// f[^
	for(y = 0; y < HEIGHT; y++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			if(filemode == MIYA_INSIDE)
			{
				if(inside[x][y] == REGIONINSIDE || inside[x][y] == REGIONBOUNDARY) ar << (unsigned char)1;
				else if(inside[x][y] == REGIONOUTSIDE) ar << (unsigned char)0;
				else ar << (unsigned char)0;
			}
			for(c = 0; c < 3; c++)
			{
				if(filemode == MIYA_COORDNEEDLE) ar << coordnormal[x][y][c];
			}
		}
	}

	ar.Close();
	cf.Close();
}

// 摜𐶐
void CLayerView::CreateImages(void)
{
	CWaitCursor wait;
	int x, y;
	int i;
	double p;
	int r, g, b;
	int m;
	double BASISMAX = 1.0 / (double)PIXELNUM * 2000.0;

	// f[^`FbN
	if(!processdone[viewmode])
	{
		for(i = 0; i < 4 * WIDTH * HEIGHT; i++) screendata[i] = 0;
		return;
	}

	// 摜`
	if(viewmode == MIYA_PSEUDONEEDLE) CreateNeedleImage(MIYA_PSEUDONEEDLE);
	if(viewmode == MIYA_NEEDLECONSTRAINT) CreateNeedleImage(MIYA_NEEDLECONSTRAINT);
	if(viewmode == MIYA_NEEDLEBOUNDARY) CreateNeedleImage(MIYA_NEEDLEBOUNDARY);
	if(viewmode == MIYA_COORDNEEDLE) CreateNeedleImage(MIYA_COORDNEEDLE);
	if(viewmode == MIYA_IDEAL) CreateIdealImage();

	// 摜f[^쐬
	i = 0;
	for(y = 0; y < HEIGHT; y++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			m = -1;
			if(viewmode == MIYA_INPUT)
			{
				r = (int)inputimage[imgarry(imageview,x,y,COLR)];
				g = (int)inputimage[imgarry(imageview,x,y,COLG)];
				b = (int)inputimage[imgarry(imageview,x,y,COLB)];
				m = 2;
			}
			if(viewmode == MIYA_SHADOWINIT)
			{
				if(shadowinit[pixarry(imageview,x,y)]) p = 1.0;
				else p = 0.0;
				m = 0;
			}
			if(viewmode == MIYA_SPECULARINIT)
			{
				if(specularinit[pixarry(imageview,x,y)]) p = 1.0;
				else p = 0.0;
				m = 0;
			}
			if(viewmode == MIYA_VALIDPIXEL)
			{
				if(validpixel[x][y]) p = 1.0;
				else p = 0.0;
				m = 0;
			}
			if(viewmode == MIYA_PSEUDOZENITH)
			{
				p = pseudonormal[x][y][AXISZ];
				if(p < 0.0) p = 0.0;
				if(p > 1.0) p = 1.0;
				p = acos(p);
				p = p / (PI / 2.0);
				m = 0;
			}
			if(viewmode == MIYA_PSEUDOAZIMUTH)
			{
				p = atan2(pseudonormal[x][y][AXISY], pseudonormal[x][y][AXISX]);
				if(p < 0.0) p += PI * 2.0;
				p = p / (PI * 2.0);
				m = 1;
			}
			if(viewmode == MIYA_PSEUDONEEDLE)
			{
				r = (int)needleimage[x][y][COLR];
				g = (int)needleimage[x][y][COLG];
				b = (int)needleimage[x][y][COLB];
				m = 2;
			}
			if(viewmode == MIYA_IDEAL)
			{
				r = (int)idealimage[x][y][COLR];
				g = (int)idealimage[x][y][COLG];
				b = (int)idealimage[x][y][COLB];
				m = 2;
			}
			if(viewmode == MIYA_BASIS1) {
				p = eigens[pixarry(x,y)][0] / BASISMAX;
				m = 3;
			}
			if(viewmode == MIYA_BASIS2) {
				p = eigens[pixarry(x,y)][1] / BASISMAX;
				m = 3;
			}
			if(viewmode == MIYA_BASIS3) {
				p = eigens[pixarry(x,y)][2] / BASISMAX;
				m = 3;
			}
			if(viewmode == MIYA_SHADOWOPT)
			{
				if(shadowopt[pixarry(imageview,x,y)]) p = 1.0;
				else p = 0.0;
				m = 0;
			}
			if(viewmode == MIYA_SPECULAROPT)
			{
				if(specularopt[pixarry(imageview,x,y)]) p = 1.0;
				else p = 0.0;
				m = 0;
			}
			if(viewmode == MIYA_MEDIAN)
			{
				r = (int)medianimage[x][y][COLR];
				g = (int)medianimage[x][y][COLG];
				b = (int)medianimage[x][y][COLB];
				m = 2;
			}
			if(viewmode == MIYA_REGION)
			{
				if(region[x][y]) p = 1.0;
				else p = 0.0;
				m = 0;
			}
			if(viewmode == MIYA_ALBEDO)
			{
				r = (int)floor(albedo[x][y][COLR]);
				g = (int)floor(albedo[x][y][COLG]);
				b = (int)floor(albedo[x][y][COLB]);
				m = 2;
			}
			if(viewmode == MIYA_ZENITHCONSTRAINT)
			{
				p = normalconstraint[x][y][AXISZ];
				if(p < 0.0) p = 0.0;
				if(p > 1.0) p = 1.0;
				p = acos(p);
				p = p / (PI / 2.0);
				m = 0;
			}
			if(viewmode == MIYA_AZIMUTHCONSTRAINT)
			{
				p = atan2(normalconstraint[x][y][AXISY], normalconstraint[x][y][AXISX]);
				if(p < 0.0) p += PI * 2.0;
				p = p / (PI * 2.0);
				m = 1;
			}
			if(viewmode == MIYA_NEEDLECONSTRAINT)
			{
				r = (int)needleimage[x][y][COLR];
				g = (int)needleimage[x][y][COLG];
				b = (int)needleimage[x][y][COLB];
				m = 2;
			}
			if(viewmode == MIYA_INSIDE)
			{
				if(inside[x][y] == REGIONOUTSIDE) p = 0.0;
				if(inside[x][y] == REGIONINSIDE) p = 0.5;
				if(inside[x][y] == REGIONBOUNDARY) p = 1.0;
				m = 0;
			}
			if(viewmode == MIYA_ZENITHBOUNDARY)
			{
				p = normalboundary[x][y][AXISZ];
				if(p < 0.0) p = 0.0;
				if(p > 1.0) p = 1.0;
				p = acos(p);
				p = p / (PI / 2.0);
				m = 0;
			}
			if(viewmode == MIYA_AZIMUTHBOUNDARY)
			{
				p = atan2(normalboundary[x][y][AXISY], normalboundary[x][y][AXISX]);
				if(p < 0.0) p += PI * 2.0;
				p = p / (PI * 2.0);
				m = 1;
			}
			if(viewmode == MIYA_NEEDLEBOUNDARY)
			{
				r = (int)needleimage[x][y][COLR];
				g = (int)needleimage[x][y][COLG];
				b = (int)needleimage[x][y][COLB];
				m = 2;
			}
			if(viewmode == MIYA_COORDZENITH)
			{
				p = coordnormal[x][y][AXISZ];
				if(p < 0.0) p = 0.0;
				if(p > 1.0) p = 1.0;
				p = acos(p);
				p = p / (PI / 2.0);
				m = 0;
			}
			if(viewmode == MIYA_COORDAZIMUTH)
			{
				p = atan2(coordnormal[x][y][AXISY], coordnormal[x][y][AXISX]);
				if(p < 0.0) p += PI * 2.0;
				p = p / (PI * 2.0);
				m = 1;
			}
			if(viewmode == MIYA_COORDNEEDLE)
			{
				r = (int)needleimage[x][y][COLR];
				g = (int)needleimage[x][y][COLG];
				b = (int)needleimage[x][y][COLB];
				m = 2;
			}
			if(viewmode == MIYA_TRICOLOR)
			{
				r = (int)tricolor[imgarry(x,y,COLR)];
				g = (int)tricolor[imgarry(x,y,COLG)];
				b = (int)tricolor[imgarry(x,y,COLB)];
				m = 2;
			}

			if(m == 0)
			{
				if(colormode)
				{
					if(p < 0.2)
					{
						p = p * 5.0;
						r = 0;
						g = 0;
						b = (int)(p * 255.0);
					}
					else if(p < 0.4)
					{
						p = p - 0.2;
						p = p * 5.0;
						r = 0;
						g = (int)(p * 255.0);
						b = 255;
					}
					else if(p < 0.6)
					{
						p = p - 0.4;
						p = p * 5.0;
						r = 0;
						g = 255;
						b = (int)((1.0 - p) * 255.0);
					}
					else if(p < 0.8)
					{
						p = p - 0.6;
						p = p * 5.0;
						r = (int)(p * 255.0);
						g = 255;
						b = 0;
					}
					else
					{
						p = p - 0.8;
						p = p * 5.0;
						r = 255;
						g = (int)((1.0 - p) * 255.0);
						b = 0;
					}
				}
				else
				{
					r = g = b = (int)(p * 255.0);
				}
			}
			else if(m == 1)
			{
				if(colormode)
				{
					if(p < 1.0 / 6.0)
					{
						p = p * 6.0;
						r = 255;
						g = (int)(p * 255.0);
						b = 0;
					}
					else if(p < 2.0 / 6.0)
					{
						p = p - 1.0 / 6.0;
						p = p * 6.0;
						r = (int)((1.0 - p) * 255.0);
						g = 255;
						b = 0;
					}
					else if(p < 3.0 / 6.0)
					{
						p = p - 2.0 / 6.0;
						p = p * 6.0;
						r = 0;
						g = 255;
						b = (int)(p * 255.0);
					}
					else if(p < 4.0 / 6.0)
					{
						p = p - 3.0 / 6.0;
						p = p * 6.0;
						r = 0;
						g = (int)((1.0 - p) * 255.0);
						b = 255;
					}
					else if(p < 5.0 / 6.0)
					{
						p = p - 4.0 / 6.0;
						p = p * 6.0;
						r = (int)(p * 255.0);
						g = 0;
						b = 255;
					}
					else
					{
						p = p - 5.0 / 6.0;
						p = p * 6.0;
						r = 255;
						g = 0;
						b = (int)((1.0 - p) * 255.0);
					}
				}
				else
				{
					p = fabs(p - 0.5);
					p = p * 255.0;
					r = g = b = (int)p;
				}
			}
			else if(m == 2)
			{
				if(!colormode) r = g = b = (r + 2 * g + b) / 4;
			} else if(m == 3) {
				r = g = b = 0;
				if(colormode) {
					if(p > 0.0) g = (int)(255.0 * p);
					else r = -(int)(255.0 * p);
				} else {
					r = g = b = (int)((p + 1.0) / 2.0 * 255.0);
				}
			}

			if(r > 255) r = 255;
			if(g > 255) g = 255;
			if(b > 255) b = 255;
			if(r < 0) r = 0;
			if(g < 0) g = 0;
			if(b < 0) b = 0;
			screendata[i] = b;
			i++;
			screendata[i] = g;
			i++;
			screendata[i] = r;
			i++;
			screendata[i] = 0;
			i++;
		}
		if(WIDTH % 4 > 0){}//??
	}
}

// j[h}bv`
void CLayerView::CreateNeedleImage(int filemode)
{
	CWaitCursor wait;
	const int NEEDLEBLOCKSIZE = 16; // 2ȏ̋, cTCY̖񐔂Ƃꂢ
	const int NEEDLELENGTH = 14;
	int x, y;
	int c;
	int xx, yy;
	int xe, ye;
	int s;
	double nx, ny;

	// 
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			for(c = 0; c < 3; c++)
			{
				needleimage[x][y][c] = 0;
			}
		}
	}

	// Sɓ_ł
	for(x = NEEDLEBLOCKSIZE / 2; x < WIDTH; x += NEEDLEBLOCKSIZE)
	{
		for(y = NEEDLEBLOCKSIZE / 2; y < HEIGHT; y += NEEDLEBLOCKSIZE)
		{
			for(xx = x - 1; xx <= x + 1; xx++)
			{
				for(yy = y - 1; yy <= y + 1; yy++)
				{
					for(c = 0; c < 3; c++)
					{
						needleimage[xx][yy][c] = 255;
					}
				}
			}
		}
	}

	// j[h`
	for(x = NEEDLEBLOCKSIZE / 2; x < WIDTH; x += NEEDLEBLOCKSIZE)
	{
		for(y = NEEDLEBLOCKSIZE / 2; y < HEIGHT; y += NEEDLEBLOCKSIZE)
		{
			if(filemode == MIYA_PSEUDONEEDLE)
			{
				nx = pseudonormal[x][y][AXISX];
				ny = pseudonormal[x][y][AXISY];
			}
			if(filemode == MIYA_NEEDLECONSTRAINT)
			{
				nx = normalconstraint[x][y][AXISX];
				ny = normalconstraint[x][y][AXISY];
			}
			if(filemode == MIYA_NEEDLEBOUNDARY)
			{
				nx = normalboundary[x][y][AXISX];
				ny = normalboundary[x][y][AXISY];
			}
			if(filemode == MIYA_COORDNEEDLE)
			{
				nx = coordnormal[x][y][AXISX];
				ny = coordnormal[x][y][AXISY];
			}
			xe = x + (int)floor((double)NEEDLELENGTH * nx);
			ye = y + (int)floor((double)NEEDLELENGTH * ny);
			for(s = 0; s <= NEEDLELENGTH; s++)
			{
				xx = (NEEDLELENGTH - s) * x + s * xe;
				xx = (int)floor((double)xx / (double)NEEDLELENGTH + 0.5);
				yy = (NEEDLELENGTH - s) * y + s * ye;
				yy = (int)floor((double)yy / (double)NEEDLELENGTH + 0.5);
				if(xx >= 0 && xx < WIDTH && yy >= 0 && yy < HEIGHT)
				{
					for(c = 0; c < 3; c++)
					{
						needleimage[xx][yy][c] = 255;
					}
				}
			}
		}
	}
}

// z摜vZ
void CLayerView::CreateIdealImage()
{
	CWaitCursor wait;
	int x, y;
	double s;
	int r;
	double lx, ly, lz;
	int p;

	lx = matl[0][imageview];
	ly = matl[1][imageview];
	lz = matl[2][imageview];
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			p = y * WIDTH + x;
			s = DOTPRODUCT(lx, ly, lz, mats[p][0], mats[p][1], mats[p][2]);
			r = (int)floor(s);
			if(r < 0) r = 0;
			if(r > 255) r = 255;
			idealimage[x][y][COLR] = r; // ܂R`lΉĂȂ
			idealimage[x][y][COLG] = 0;
			idealimage[x][y][COLB] = 0;
		}
	}
}

// lʂvZ
double CLayerView::Quarter(double* x, int n, double RANGEMIN, double RANGEMAX)
{
	double medval;
	double maxval;
	int m;
	double* y;
	int i;

	// f[^4ȉ̏ꍇ͏ꍇŎlʂvZ
	if(n == 0) return (RANGEMIN + RANGEMAX) / 2.0;
	if(n == 1) return x[0];
	if(n == 2)
	{
		if(x[0] > x[1]) return (x[0] * 3.0 + x[1]) / 4.0;
		else return (x[1] * 3.0 + x[0]) / 4.0;
	}
	if(n == 3)
	{
		if(x[0] >= x[2] && x[1] >= x[2]) return (x[0] + x[1]) / 2.0;
		else if(x[2] >= x[1] && x[0] >= x[1]) return (x[2] + x[0]) / 2.0;
		else if(x[1] >= x[0] && x[2] >= x[0]) return (x[1] + x[2]) / 2.0;
		else
		{
			AfxMessageBox("vOɃoO܂");
			return (x[0] + x[1] + x[2]) / 3.0;
		}
	}
	if(n == 4)
	{
		if(x[0] >= x[1] && x[1] >= x[2] && x[1] >= x[3]) return (x[1] * 3.0 + x[0]) / 4.0;
		else if(x[0] >= x[2] && x[2] >= x[1] && x[2] >= x[3]) return (x[2] * 3.0 + x[0]) / 4.0;
		else if(x[0] >= x[3] && x[3] >= x[1] && x[3] >= x[2]) return (x[3] * 3.0 + x[0]) / 4.0;
		else if(x[1] >= x[0] && x[0] >= x[2] && x[0] >= x[3]) return (x[0] * 3.0 + x[1]) / 4.0;
		else if(x[1] >= x[2] && x[2] >= x[0] && x[2] >= x[3]) return (x[2] * 3.0 + x[1]) / 4.0;
		else if(x[1] >= x[3] && x[3] >= x[0] && x[3] >= x[2]) return (x[3] * 3.0 + x[1]) / 4.0;
		else if(x[2] >= x[0] && x[0] >= x[1] && x[0] >= x[3]) return (x[0] * 3.0 + x[2]) / 4.0;
		else if(x[2] >= x[1] && x[1] >= x[0] && x[1] >= x[3]) return (x[1] * 3.0 + x[2]) / 4.0;
		else if(x[2] >= x[3] && x[3] >= x[0] && x[3] >= x[1]) return (x[3] * 3.0 + x[2]) / 4.0;
		else if(x[3] >= x[0] && x[0] >= x[1] && x[0] >= x[2]) return (x[0] * 3.0 + x[3]) / 4.0;
		else if(x[3] >= x[1] && x[1] >= x[0] && x[1] >= x[2]) return (x[1] * 3.0 + x[3]) / 4.0;
		else if(x[3] >= x[2] && x[2] >= x[0] && x[2] >= x[1]) return (x[2] * 3.0 + x[3]) / 4.0;
		else
		{
			AfxMessageBox("vOɃoO܂");
			return (x[0] + x[1] + x[2] + x[3]) / 4.0;
		}
	}

	// ̊m
	try
	{
		y = new double[n];
	}
	catch(...)
	{
		AfxMessageBox("܂");
		return (RANGEMIN + RANGEMAX) / 2.0;
	}

	// lʂvZ
	medval = Median(x, n, RANGEMIN, RANGEMAX);
	maxval = medval;
	m = 0;
	for(i = 0; i < n; i++)
	{
		if(x[i] > maxval) maxval = x[i];
		if(x[i] >= medval)
		{
			y[m] = x[i];
			m++;
		}
	}
	if(m >= 2) medval = Median(y, m, medval, maxval);

	// 
	delete [] y;

	// vZʂԂ
	return medval;
}

// fBAvZ
double CLayerView::Median(double* x, int n, double RANGEMIN, double RANGEMAX)
{
	const int LOOPMAX = 10;
	const double SIMILAR = (RANGEMAX - RANGEMIN) * 0.005;
	const double BIG = fabs(RANGEMAX) + fabs(RANGEMIN) + 1.0;
	const double AFAC = 1.5;
	const double AMP = 1.0;
	int np, nm, nz, j, loop;
	double xx, xp, xm, sumx, sum, eps, stemp, dum, ap, am, aa, a;

	if(n == 0) return (RANGEMIN + RANGEMAX) / 2.0;
	if(n == 1) return x[0];
	if(n == 2) return (x[0] + x[1]) / 2.0;
	a = (x[0] + x[n - 1]) / 2.0;
	eps = RANGEMAX - RANGEMIN;
	am = -(ap = BIG);
	for(loop = 0; loop < LOOPMAX; loop++)
	{
		sum = sumx = 0.0;
		np = nm = nz = 0;
		xm = -(xp = BIG);
		for(j = 0; j < n; j++)
		{
			xx = x[j];
			if(fabs(xx - a) < SIMILAR) nz++;
			else if(xx > a)
			{
				np++;
				if(xx < xp) xp = xx;
			}
			else
			{
				nm++;
				if(xx > xm) xm = xx;
			}
			dum = fabs(xx - a);
			if(dum < SIMILAR) dum = SIMILAR;
			dum = 1.0 / (eps + dum);
			sum += dum;
			sumx += xx * dum;
		}
		stemp = (sumx / sum) - a;
		if(nm <= (n + 1) / 2 && np <= (n + 1) / 2)
		{
			if(n % 2 == 0)
			{
				if(nz >= 2) return a;
				else if(np == nm) return (xm + xp) / 2.0;
				else if(np > nm) return (a + xp) / 2.0;
				else return (xm + a) / 2.0;
			}
			else
			{
				if(nz >= 1) return a;
				else if(np > nm) return xp;
				else return xm;
			}
		}
		if(np > nm)
		{
			am = a;
			aa = stemp < 0.0 ? xp : xp + stemp * AMP;
			if(aa > ap) aa = 0.5 * (a + ap);
			eps = AFAC * fabs(aa - a);
			a = aa;
		}
		else
		{
			ap = a;
			aa = stemp > 0.0 ? xm : xm + stemp * AMP;
			if(aa < am) aa = 0.5 * (a + am);
			eps = AFAC * fabs(aa - a);
			a = aa;
		}
	}
	return a;
}

// 3x3s𒼌
void CLayerView::CalcOrthogonal(double* row0, double* row1, double* row2)
{
	double** svdu;
	double* svdw;
	double** svdv;
	int i, j, k;
	double val;

	// m
	try
	{
		svdu = new double*[3];
		svdw = new double[3];
		svdv = new double*[3];
	}
	catch(...)
	{
		AfxMessageBox("܂");
		return;
	}
	for(i = 0; i < 3; i++)
	{
		try
		{
			svdu[i] = new double[3];
			svdv[i] = new double[3];
		}
		catch(...)
		{
			AfxMessageBox("܂");
			return;
		}
	}

	// f[^̐ݒ
	for(j = 0; j < 3; j++)
	{
		svdu[0][j] = row0[j];
		svdu[1][j] = row1[j];
		svdu[2][j] = row2[j];
	}

	// 
	for(i = 0; i < 3; i++)
	{
		for(j = 0; j < 3; j++)
		{
			svdv[i][j] = 0.0;
		}
		svdw[i] = 0.0;
	}

	// ْl
	CalcSVD0(svdu, 3, 3, svdw, svdv);

	// svZ
	for(i = 0; i < 3; i++)
	{
		for(j = 0; j < 3; j++)
		{
			val = 0.0;
			for(k = 0; k < 3; k++)
			{
				val += svdu[i][k] * svdv[j][k];
			}
			if(i == 0) row0[j] = val;
			else if(i == 1) row1[j] = val;
			else row2[j] = val;
		}
	}

	// 
	for(i = 0; i < 3; i++)
	{
		delete [] svdu[i];
		delete [] svdv[i];
	}
	delete [] svdu;
	delete [] svdw;
	delete [] svdv;
}

// sa[0..m-1][0..n-1]ْlA=UWV^T郋[`DsUaɏ㏑D
// ْl̑ΊpsW̓xNgw[0..n-1]ɓDsVi]uV^Tł͂Ȃjv[0..n-1][0..n-1]
// ɓDmnłȂ΂ȂȂDm<nȂC炩ả0΂̍s
// s(m=n)ɂĂ炱ĂяoD
void CLayerView::CalcSVD0(double** a, int m, int n, double w[], double** v)
{
	double** nrcu;
	double** nrcv;
	int i;

	try
	{
		nrcu = new double*[m];
		nrcv = new double*[n];
	}
	catch(...)
	{
		return;
	}
	for(i = 0; i < m; i++) nrcu[i] = a[i] - 1;
	for(i = 0; i < n; i++) nrcv[i] = v[i] - 1;
	CalcSVD1(nrcu - 1, m, n, w - 1, nrcv - 1); // Numerical Recipes̃[`͓Y1n܂
	delete [] nrcv;
	delete [] nrcu;
}

// sa[1..m][1..n]ْlA=UWV^T郋[`DsUaɏ㏑D
// ْl̑ΊpsW̓xNgw[1..n]ɓDsVi]uV^Tł͂Ȃjv[1..n][1..n]
// ɓDmnłȂ΂ȂȂDm<nȂC炩ả0΂̍s
// s(m=n)ɂĂ炱ĂяoD
void CLayerView::CalcSVD1(double **a, int m, int n, double w[], double **v)
{
	int flag, i, its, j, jj, k, l, nm;
	double anorm, c, f, g, h, s, scale, x, y, z, *rv1;

	rv1 = new double[n + 1];
	for(i = 1; i <= n; i++) rv1[i] = 0.0;
	g = scale = anorm = 0.0; // Householder@łQdΊp̌`ɒ
	for(i = 1; i <= n; i++)
	{
		l = i + 1;
		rv1[i] = scale * g;
		g = s = scale = 0.0;
		if(i <= m)
		{
			for(k = i; k <= m; k++) scale += fabs(a[k][i]);
			if(scale)
			{
				for(k = i; k <= m; k++)
				{
					a[k][i] /= scale;
					s += a[k][i] * a[k][i];
				}
				f = a[i][i];
				g = -SIGN(sqrt(s), f);
				h = f * g - s;
				a[i][i] = f - g;
				for(j = l; j <= n; j++)
				{
					for(s = 0.0, k = i; k <= m; k++) s += a[k][i] * a[k][j];
					f = s / h;
					for(k = i; k <= m; k++) a[k][j] += f * a[k][i];
				}
				for(k = i; k <= m; k++) a[k][i] *= scale;
			}
		}
		w[i] = scale * g;
		g = s = scale = 0.0;
		if(i <= m && i != n)
		{
			for(k = l; k <= n; k++) scale += fabs(a[i][k]);
			if(scale)
			{
				for(k = l; k <= n; k++)
				{
					a[i][k] /= scale;
					s += a[i][k] * a[i][k];
				}
				f = a[i][l];
				g = -SIGN(sqrt(s), f);
				h = f * g - s;
				a[i][l] = f - g;
				for(k = l; k <= n; k++) rv1[k] = a[i][k] / h;
				for(j = l; j <= m; j++)
				{
					for(s = 0.0, k = l; k <= n; k++) s += a[j][k] * a[i][k];
					for(k = l; k <= n; k++) a[j][k] += s * rv1[k];
				}
				for(k = l; k <= n; k++) a[i][k] *= scale;
			}
		}
		anorm = FMAX(anorm, fabs(w[i]) + fabs(rv1[i]));
	}
	for(i = n; i >= 1; i--) // E̕ϊ̗ݐ
	{
		if(i < n)
		{
			if(g)
			{
				for(j = l; j <= n; j++) v[j][i] = (a[i][j] / a[i][l]) / g; // A_[t[邽߁CQx肷
				for(j = l; j <= n; j++)
				{
					for(s = 0.0, k = l; k <= n; k++) s += a[i][k] * v[k][j];
					for(k = l; k <= n; k++) v[k][j] += s * v[k][i];
				}
			}
			for(j = l; j <= n; j++) v[i][j] = v[j][i] = 0.0;
		}
		v[i][i] = 1.0;
		g = rv1[i];
		l = i;
	}
	for(i = IMIN(m, n); i >= 1; i--) // ̕ϊ̗ݐ
	{
		l = i + 1;
		g = w[i];
		for(j = l; j <= n; j++) a[i][j] = 0.0;
		if(g)
		{
			g = 1.0 / g;
			for(j = l; j <= n; j++)
			{
				for(s = 0.0, k = l; k <= m; k++) s += a[k][i] * a[k][j];
				f = (s / a[i][i]) * g;
				for(k = i; k <= m; k++) a[k][j] += f * a[k][i];
			}
			for(j = i; j <= m; j++) a[j][i] *= g;
		}
		else
		{
			for(j = i; j <= m; j++) a[j][i] = 0.0;
		}
		++a[i][i];
	}
	for(k = n; k >= 1; k--) // QdΊps̑ΊpFْlɂẴ[vƁCvZ̃[v
	{
		for(its = 1; its <= 30; its++)
		{
			flag = 1;
			for(l = k; l >= 1; l--) // ̃`FbN
			{
				nm = l - 1; // rv1[1]͏0
				if(fabs(rv1[l]) < EPS)
				{
					flag = 0;
					break;
				}
				if(fabs(w[nm]) < EPS) break;
			}
			if(flag)
			{
				c = 0.0; // l>1̂Ƃrv1[l]
				s = 1.0;
				for(i = l; i <= k; i++)
				{
					f = s * rv1[i];
					rv1[i] = c * rv1[i];
					if(fabs(f) < EPS) break;
					g = w[i];
					h = pythag(f, g);
					w[i] = h;
					h = 1.0 / h;
					c = g * h;
					s = -f * h;
					for(j = 1; j <= m; j++)
					{
						y = a[j][nm];
						z = a[j][i];
						a[j][nm] = y * c + z * s;
						a[j][i] = z * c - y * s;
					}
				}
			}
			z = w[k];
			if(l == k) // 
			{
				if(z < 0.0) // ْl񕉂ɂ
				{
					w[k] = -z;
					for(j = 1; j <= n; j++) v[j][k] = -v[j][k];
				}
				break;
			}
			if(its == 30) AfxMessageBox("no convergence in 30 svdcmp iterations"); // 30JԂĂȂ
			x = w[l]; // ŉ̂QsQ̏s񎮂̃Vtg
			nm = k - 1;
			y = w[nm];
			g = rv1[nm];
			h = rv1[k];
			f = ((y - z) * (y + z) + (g - h) * (g + h)) / (2.0 * h * y);
			g = pythag(f, 1.0);
			f = ((x - z) * (x + z) + h * ((y / (f + SIGN(g, f))) - h)) / x;
			c = s = 1.0; // QRϊ
			for(j = l; j <= nm; j++)
			{
				i = j + 1;
				g = rv1[i];
				y = w[i];
				h = s * g;
				g = c * g;
				z = pythag(f, h);
				rv1[j] = z;
				c = f / z;
				s = h / z;
				f = x * c + g * s;
				g = g * c - x * s;
				h = y * s;
				y *= c;
				for(jj = 1; jj <= n; jj++)
				{
					x = v[jj][j];
					z = v[jj][i];
					v[jj][j] = x * c + z * s;
					v[jj][i] = z * c - x * s;
				}
				z = pythag(f, h);
				w[j] = z; // z = 0Ȃ]͔C
				if(z)
				{
					z = 1.0 / z;
					c = f * z;
					s = h * z;
				}
				f = c * g + s * y;
				x = c * y - s * g;
				for(jj = 1; jj <= m; jj++)
				{
					y = a[jj][j];
					z = a[jj][i];
					a[jj][j] = y * c + z * s;
					a[jj][i] = z * c - y * s;
				}
			}
			rv1[l] = 0.0;
			rv1[k] = f;
			w[k] = x;
		}
	}
	delete [] rv1;
}

// sqrt(a^2 + b^2)vZDA_[t[I[o[t[ȂD
double CLayerView::pythag(double a, double b)
{
	double absa, absb;
	absa = fabs(a);
	absb = fabs(b);
	if(absa > absb) return absa * sqrt(1.0 + SQR(absb / absa));
	else return (absb == 0.0 ? 0.0 : absb * sqrt(1.0 + SQR(absa / absb)));
}

// ArGgspecular/shadow̏lvZ
void CLayerView::OnCalcInit()
{
	CWaitCursor wait;
	CTime ctStart;
	CTime ctEnd;
	CTimeSpan ctInterval;
	DWORD tickStart;
	DWORD tickEnd;
	DWORD tickInterval;
	CString str;
	int x, y;
	int i;
	const unsigned char IMINSVD = 18;
	const unsigned char IMAXSVD = 160;

	// `FbN
	if(!processdone[MIYA_INPUT]) return;

	// Jnݒ
	ctStart = CTime::GetCurrentTime();
	tickStart = ::GetTickCount();

	// specularshadowo
	for(i = 0; i < imagenum; i++) {
		for(x = 0; x < WIDTH; x++) {
			for(y = 0; y < HEIGHT; y++) {
				if(inputvalue(i,x,y) <= IMINSVD) shadowinit[pixarry(i,x,y)] = true;
				else shadowinit[pixarry(i,x,y)] = false;
				if(inputvalue(i,x,y) >= IMAXSVD) specularinit[pixarry(i,x,y)] = true;
				else specularinit[pixarry(i,x,y)] = false;
			}
		}
	}

	// IbZ[W
	ctEnd = CTime::GetCurrentTime();
	ctInterval = ctEnd - ctStart;
	tickEnd = ::GetTickCount();
	tickInterval = tickEnd - tickStart;
	str = "vZI܂\n";
	str += "\n";
	str += "Jn: " + ctStart.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "I: " + ctEnd.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "oߎ: " + ctInterval.Format("%H:%M:%S") + "\n";
	str.AppendFormat("oߎ: %dm~bn\n",  tickInterval);
	str += "\n";

	// ㏈
	processdone[MIYA_SHADOWINIT] = true;
	processdone[MIYA_SPECULARINIT] = true;
	viewmode = MIYA_SHADOWINIT;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
	AfxMessageBox(str);
}

// ْls
void CLayerView::OnCalcSvd()
{
	CWaitCursor wait;
	CTime ctStart;
	CTime ctEnd;
	CTimeSpan ctInterval;
	DWORD tickStart;
	DWORD tickEnd;
	DWORD tickInterval;
	CString str;
	int x, y;
	int i;
	int p;
	double** svdu;
	double* svdw;
	double** svdv;
	double sval[4];
	int k;
	double maxw;
	int maxi;
	double nx, ny, nz;
	double r;
	const int INTENSITYNUM = imagenum * 18 / 100;
	const unsigned char IMINLSM = 10;
	const unsigned char IMAXLSM = 190;
	int validnum;
	double** lsml;
	double* lsmi;
	double* lsmw;
	double** lsmv;
	int diffusenum;
	int j;
	double val;
	int invalidnum;

	// `FbN
	if(!processdone[MIYA_INPUT]) return;

	// ̊m
	try
	{
		svdu = new double*[PIXELNUM + 1];
		svdw = new double[imagenum + 1];
		svdv = new double*[imagenum + 1];
		lsml = new double*[imagenum];
		lsmi = new double[imagenum];
		lsmw = new double[3];
		lsmv = new double*[3];
	}
	catch(...)
	{
		AfxMessageBox("܂");
		return;
	}
	for(p = 1; p <= PIXELNUM; p++)
	{
		try
		{
			svdu[p] = new double[imagenum + 1];
		}
		catch(...)
		{
			AfxMessageBox("܂");
			return;
		}
	}
	for(i = 1; i <= imagenum; i++)
	{
		try
		{
			svdv[i] = new double[imagenum + 1];
		}
		catch(...)
		{
			AfxMessageBox("܂");
			return;
		}
	}
	for(i = 0; i < imagenum; i++)
	{
		try
		{
			lsml[i] = new double[3];
		}
		catch(...)
		{
			AfxMessageBox("܂");
			return;
		}
	}
	for(i = 0; i < 3; i++)
	{
		try
		{
			lsmv[i] = new double[3];
		}
		catch(...)
		{
			AfxMessageBox("܂");
			return;
		}
	}

	// Jnݒ
	ctStart = CTime::GetCurrentTime();
	tickStart = ::GetTickCount();

	// ẽsNZƋʔ˂̃sNZxCvZ菜
	for(x = 0; x < WIDTH; x++) {
		for(y = 0; y < HEIGHT; y++) {
			invalidnum = 0;
			for(i = 0; i < imagenum; i++)
			{
				if(shadowinit[pixarry(i,x,y)] || specularinit[pixarry(i,x,y)]) invalidnum++;
			}
			if(invalidnum >= INTENSITYNUM) validpixel[x][y] = false;
			else validpixel[x][y] = true;
		}
	}

	// vZɎgf̐𐔂グ
	validnum = 0;
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			if(validpixel[x][y]) validnum++;
		}
	}
	if(validnum < imagenum)
	{
		AfxMessageBox("e⋾ʔ˂ČvZł܂");
		return;
	}

	// SVD̂߂̏ݒ
	// Numerical Recipes͔z̓Y1n܂
	// E摜̖Ń[v
	for(i = 1; i <= imagenum; i++)
	{
		// sE摜̃sNZŃ[v
		// sNZ̕т͉摜̃XLCI[_[
		// Lȉf݂̂I
		p = 1;
		for(y = 0; y < HEIGHT; y++)
		{
			for(x = 0; x < WIDTH; x++)
			{
				if(validpixel[x][y])
				{
					svdu[p][i] = (double)inputvalue(i-1,x,y);
					p++;
				}
			}
		}
	}

	// WV
	for(i = 1; i <= imagenum; i++)
	{
		svdw[i] = 0.0;
		for(p = 1; p <= imagenum; p++)
		{
			svdv[i][p] = 0.0;
		}
	}

	// SVDvZ
	CalcSVD1(svdu, validnum, imagenum, svdw, svdv);

	// ْl̑傫ɂRo
	for(k = 0; k < 4; k++)
	{
		if(k == 3 && imagenum == 3)
		{
			AfxMessageBox("摜̖R܂");
			break;
		}

		// ْlő̕T
		maxw = -INF;
		maxi = 1;
		for(i = 1; i <= imagenum; i++)
		{
			if(svdw[i] >= maxw)
			{
				maxw = svdw[i];
				maxi = i;
			}
		}

		// ْlۑC
		// ْ̓l폜
		sval[k] = maxw;
		svdw[maxi] = 0.0;

		// ̃f[^o
		if(k < 3)
		{
			// USɃRs[
			// U͓Y1CS͓Y0
			for(p = 0; p < validnum; p++) mats[p][k] = svdu[p + 1][maxi];

			// VLɃRs[
			// V͓Y1CL͓Y0
			for(i = 0; i < imagenum; i++) matl[k][i] = svdv[i + 1][maxi];
		}
	}

	// ْĺvZ
	for(k = 0; k < 4; k++)
	{
		if(k == 3 && imagenum == 3)
		{
			AfxMessageBox("摜̖R܂");
			break;
		}
		sval[k] = sqrt(sval[k]);
	}

	//// [\ʍsƋ[svZ
	//// BɂvX̉ƃ}CiX̉邪Cł̓vX̉vZ
	//for(p = 0; p < validnum; p++)
	//{
	//	mats[p][0] *= sval[0];
	//	mats[p][1] *= sval[1];
	//	mats[p][2] *= sval[2];
	//}
	//for(i = 0; i < imagenum; i++)
	//{
	//	matl[0][i] *= sval[0];
	//	matl[1][i] *= sval[1];
	//	matl[2][i] *= sval[2];
	//}

	// [\ʍsƋ[svZ
	// BɂvX̉ƃ}CiX̉邪Cł̓vX̉vZ
	for(p = 0; p < validnum; p++)
	{
		mats[p][0] *= 1.0;
		mats[p][1] *= 1.0;
		mats[p][2] *= 1.0;
	}
	for(i = 0; i < imagenum; i++)
	{
		matl[0][i] *= sval[0] * sval[0];
		matl[1][i] *= sval[1] * sval[1];
		matl[2][i] *= sval[2] * sval[2];
	}

	// [\ʍsRs[
	p = 0;
	for(y = 0; y < HEIGHT; y++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			if(validpixel[x][y])
			{
				pseudonormal[x][y][AXISX] = mats[p][AXISX];
				pseudonormal[x][y][AXISY] = mats[p][AXISY];
				pseudonormal[x][y][AXISZ] = mats[p][AXISZ];
				p++;
			}
		}
	}

	// Of̋[\ʃxNgvZ
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			// vZɎgpf𒊏o
			diffusenum = 0;
			for(i = 0; i < imagenum; i++)
			{
				if(inputvalue(i,x,y) >= IMINLSM && inputvalue(i,x,y) <= IMAXLSM)
				{
					lsml[diffusenum][AXISX] = matl[AXISX][i];
					lsml[diffusenum][AXISY] = matl[AXISY][i];
					lsml[diffusenum][AXISZ] = matl[AXISZ][i];
					lsmi[diffusenum] = (double)inputvalue(i,x,y);
					diffusenum++;
				}
			}
			if(diffusenum <= 3)
			{
				diffusenum = 0;
				for(i = 0; i < imagenum; i++)
				{
					lsml[diffusenum][AXISX] = matl[AXISX][i];
					lsml[diffusenum][AXISY] = matl[AXISY][i];
					lsml[diffusenum][AXISZ] = matl[AXISZ][i];
					lsmi[diffusenum] = (double)inputvalue(i,x,y);
					diffusenum++;
				}
			}

			// ْl
			CalcSVD0(lsml, diffusenum, 3, lsmw, lsmv);

			// ْl̋tvZ
			lsmw[0] = 1.0 / lsmw[0];
			lsmw[1] = 1.0 / lsmw[1];
			lsmw[2] = 1.0 / lsmw[2];

			// W^-1 * U^T * lsmi vZlsmwɓD̓xNg
			for(j = 0; j < 3; j++)
			{
				val = 0.0;
				for(i = 0; i < diffusenum; i++)
				{
					val += lsml[i][j] * lsmi[i];
				}
				lsmw[j] *= val;
			}

			// V * (W^-1 * U^T * lsmi) vZnx,ny,nzɓ
			nx = ny = nz = 0.0;
			for(i = 0; i < 3; i++) nx += lsmv[0][i] * lsmw[i];
			for(i = 0; i < 3; i++) ny += lsmv[1][i] * lsmw[i];
			for(i = 0; i < 3; i++) nz += lsmv[2][i] * lsmw[i];

			// @ۑ
			pseudonormal[x][y][AXISX] = nx;
			pseudonormal[x][y][AXISY] = ny;
			pseudonormal[x][y][AXISZ] = nz;
		}
	}

	// [\ʍsvZ
	p = 0;
	for(y = 0; y < HEIGHT; y++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			mats[p][AXISX] = pseudonormal[x][y][AXISX];
			mats[p][AXISY] = pseudonormal[x][y][AXISY];
			mats[p][AXISZ] = pseudonormal[x][y][AXISZ];
			p++;
		}
	}

	// [@Ƌ[AxhvZ
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			nx = pseudonormal[x][y][AXISX];
			ny = pseudonormal[x][y][AXISY];
			nz = pseudonormal[x][y][AXISZ];
			r = NORM(nx, ny, nz);
			if(r > EPS)
			{
				nx /= r;
				ny /= r;
				nz /= r;
			}
			else
			{
				nx = 0.0;
				ny = 0.0;
				nz = 1.0;
			}
			pseudonormal[x][y][AXISX] = nx;
			pseudonormal[x][y][AXISY] = ny;
			pseudonormal[x][y][AXISZ] = nz;
			pseudoalbedo[x][y][COLR] = r; // ݂̏CR`l݂̂gp
			pseudoalbedo[x][y][COLG] = 0;
			pseudoalbedo[x][y][COLB] = 0;
		}
	}

	// IbZ[W
	ctEnd = CTime::GetCurrentTime();
	ctInterval = ctEnd - ctStart;
	tickEnd = ::GetTickCount();
	tickInterval = tickEnd - tickStart;
	str = "vZI܂\n";
	str += "\n";
	str += "Jn: " + ctStart.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "I: " + ctEnd.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "oߎ: " + ctInterval.Format("%H:%M:%S") + "\n";
	str.AppendFormat("oߎ: %dm~bn\n",  tickInterval);
	str += "\n";
	str.AppendFormat("ْl\n%1.15f\n%1.15f\n%1.15f\n%1.15f\n", SQR(sval[0]), SQR(sval[1]), SQR(sval[2]), SQR(sval[3]));
	str.AppendFormat("vZɎgpf: %d\n", validnum);
	str += "ŗLlْl";

	// 
	for(p = 1; p <= PIXELNUM; p++)
	{
		delete [] svdu[p];
	}
	delete [] svdu;
	delete [] svdw;
	for(i = 1; i <= imagenum; i++)
	{
		delete [] svdv[i];
	}
	delete [] svdv;
	for(i = 0; i < imagenum; i++)
	{
		delete [] lsml[i];
	}
	delete [] lsml;
	delete [] lsmi;
	delete [] lsmw;
	for(i = 0; i < 3; i++)
	{
		delete [] lsmv[i];
	}
	delete [] lsmv;

	// ㏈
	processdone[MIYA_VALIDPIXEL] = true;
	processdone[MIYA_PSEUDOZENITH] = true;
	processdone[MIYA_PSEUDOAZIMUTH] = true;
	processdone[MIYA_PSEUDONEEDLE] = true;
	processdone[MIYA_IDEAL] = true;
	viewmode = MIYA_PSEUDOZENITH;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
	AfxMessageBox(str);
}

// œK
void CLayerView::OnCalcOptimize()
{
	CWaitCursor wait;
	CTime ctStart;
	CTime ctEnd;
	CTimeSpan ctInterval;
	DWORD tickStart;
	DWORD tickEnd;
	DWORD tickInterval;
	CString str;
	int p, i;
	int x, y;
	int loopopt;
	const int LOOPOPTMAX = 4;

	// `FbN
	if(!processdone[MIYA_INPUT] || !processdone[MIYA_SHADOWINIT] ||
		!processdone[MIYA_SPECULARINIT] || !processdone[MIYA_PSEUDONEEDLE]) return;

	// Jnݒ
	ctStart = CTime::GetCurrentTime();
	tickStart = ::GetTickCount();

	// ʔ˂ƉeRs[
	for(i = 0; i < imagenum; i++) {
		for(y = 0; y < HEIGHT; y++) {
			for(x = 0; x < WIDTH; x++) {
				shadowopt[pixarry(i,x,y)] = shadowinit[pixarry(i,x,y)];
				specularopt[pixarry(i,x,y)] = specularinit[pixarry(i,x,y)];
			}
		}
	}

	// ƌWRs[
	for(p = 0; p < PIXELNUM; p++) {
		eigens[p][0] = mats[p][0];
		eigens[p][1] = mats[p][1];
		eigens[p][2] = mats[p][2];
	}
	for(i = 0; i < imagenum; i++) {
		eigenl[0][i] = matl[0][i];
		eigenl[1][i] = matl[1][i];
		eigenl[2][i] = matl[2][i];
	}

	// œKvZ
	for(loopopt = 0; loopopt < LOOPOPTMAX; loopopt++) {
		// œK
		CalcOptimalBasis();

		// eo
		CalcOptimalShadow();

		// ʔ˂o
		CalcOptimalSpecular();
	}

	// IbZ[W
	ctEnd = CTime::GetCurrentTime();
	ctInterval = ctEnd - ctStart;
	tickEnd = ::GetTickCount();
	tickInterval = tickEnd - tickStart;
	str = "vZI܂\n";
	str += "\n";
	str += "Jn: " + ctStart.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "I: " + ctEnd.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "oߎ: " + ctInterval.Format("%H:%M:%S") + "\n";
	str.AppendFormat("oߎ: %dm~bn\n",  tickInterval);

	// ㏈
	processdone[MIYA_BASIS1] = true;
	processdone[MIYA_BASIS2] = true;
	processdone[MIYA_BASIS3] = true;
	processdone[MIYA_SHADOWOPT] = true;
	processdone[MIYA_SPECULAROPT] = true;
	viewmode = MIYA_BASIS3;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
	AfxMessageBox(str);
}

// œK
void CLayerView::CalcOptimalBasis()
{
	const int BASISMINNUM = 3;
	const int LOOPDOTPRODUCTMAX = 4;
	const int LODMAXS = 3;
	const int LODMAXL = 3;
	const int LOOPSVDSTART = LODMAXS + LODMAXL;
	double** svdu;
	double* svdw;
	double** svdv;
	double* sval;
	bool** valids;
	bool** validl;
	double** tempvec;
	CList<MiyaBasisSort> sortlist;
	MiyaBasisSort sortunit;
	MiyaBasisSort sorttemp;
	POSITION pos;
	int x, y;
	int p;
	int i;
	int j;
	int k;
	int l;
	int l1, l2;
	int num;
	int maxi;
	int validnum;
	int blocknum;
	int loopsvd;
	int loopdotproduct;
	double maxw;
	double val;
	double numerator;
	double denominator;

	// m
	svdu = NULL;
	svdw = NULL;
	svdv = NULL;
	sval = NULL;
	valids = NULL;
	validl = NULL;
	tempvec = NULL;
	svdu = new double*[PIXELNUM];
	svdw = new double[imagenum];
	svdv = new double*[imagenum];
	sval = new double[3];
	valids = new bool*[LODMAXS];
	validl = new bool*[LODMAXL];
	tempvec = new double*[3];
	if(svdu == NULL || svdw == NULL || svdv == NULL || sval == NULL ||
		valids == NULL || validl == NULL || tempvec == NULL) {
		AfxMessageBox("No memory");
		return;
	}
	for(p = 0; p < PIXELNUM; p++) {
		svdu[p] = NULL;
		svdu[p] = new double[imagenum];
		if(svdu[p] == NULL) {
			AfxMessageBox("No memory");
			return;
		}
	}
	for(i = 0; i < imagenum; i++) {
		svdv[i] = NULL;
		svdv[i] = new double[imagenum];
		if(svdv[i] == NULL) {
			AfxMessageBox("No memory");
			return;
		}
	}
	for(k = 0; k < LODMAXS; k++) {
		valids[k] = NULL;
		valids[k] = new bool[PIXELNUM];
		if(valids[k] == NULL) {
			AfxMessageBox("No memory");
			return;
		}
	}
	for(k = 0; k < LODMAXL; k++) {
		validl[k] = NULL;
		validl[k] = new bool[imagenum];
		if(validl[k] == NULL) {
			AfxMessageBox("No memory");
			return;
		}
	}
	for(k = 0; k < 3; k++) {
		tempvec[k] = NULL;
		tempvec[k] = new double[PIXELNUM > imagenum ? PIXELNUM : imagenum];
		if(tempvec[k] == NULL) {
			AfxMessageBox("No memory");
			return;
		}
	}

	if(LOOPSVDSTART % 2 == 0) {
		// Cg̊𐳋K
		for(l = 0; l < 3; l++) {
			val = 0.0;
			for(i = 0; i < imagenum; i++) {
				val += eigenl[l][i] * eigenl[l][i];
			}
			val = sqrt(val);
			for(i = 0; i < imagenum; i++) {
				eigenl[l][i] /= val;
			}
		}
	} else {
		// sNZ̊𐳋K
		for(l = 0; l < 3; l++) {
			val = 0.0;
			for(p = 0; p < PIXELNUM; p++) {
				val += eigens[p][l] * eigens[p][l];
			}
			val = sqrt(val);
			for(p = 0; p < PIXELNUM; p++) {
				eigens[p][l] /= val;
			}
		}
	}

	////////////////////////////////////////////////////////////////////////////////////////////////////
	// outlierTāCs𕪊

	// \[g[esNZ]
	sortlist.RemoveAll();
	for(p = 0; p < PIXELNUM; p++) {
		// outlier̐𐔂
		y = p / WIDTH;
		x = p % WIDTH;
		sortunit.pix = p;
		sortunit.num = 0;
		for(i = 0; i < imagenum; i++) {
			if(shadowopt[pixarry(i,x,y)] || specularopt[pixarry(i,x,y)]) sortunit.num++;
		}
		
		// }ꏊT
		pos = sortlist.GetHeadPosition();
		while(pos != NULL) {
			sorttemp = sortlist.GetAt(pos);
			if(sortunit.num <= sorttemp.num) break;
			sortlist.GetNext(pos);
		}
		if(pos == NULL) sortlist.AddTail(sortunit);
		else sortlist.InsertBefore(pos, sortunit);
	}

	// 35%̃sNZOsNZƂĐݒ
	for(p = 0; p < PIXELNUM; p++) valids[0][p] = true;
	validnum = (int)((double)PIXELNUM * 0.35);
	pos = sortlist.GetTailPosition();
	for(p = 0; p < validnum; p++) {
		if(pos == NULL) break;
		sorttemp = sortlist.GetPrev(pos);
		valids[0][sorttemp.pix] = false;
	}

	// \[g[eCg]
	sortlist.RemoveAll();
	for(i = 0; i < imagenum; i++) {
		// outlier̐𐔂
		sortunit.pix = i;
		sortunit.num = 0;
		for(p = 0; p < PIXELNUM; p++) {
			y = p / WIDTH;
			x = p % WIDTH;
			if(valids[0][p]) {
				if(shadowopt[pixarry(i,x,y)] || specularopt[pixarry(i,x,y)]) sortunit.num++;
			}
		}
		
		// }ꏊT
		pos = sortlist.GetHeadPosition();
		while(pos != NULL) {
			sorttemp = sortlist.GetAt(pos);
			if(sortunit.num <= sorttemp.num) break;
			sortlist.GetNext(pos);
		}
		if(pos == NULL) sortlist.AddTail(sortunit);
		else sortlist.InsertBefore(pos, sortunit);
	}

	// 15%̃CgOCgƂĐݒ
	for(i = 0; i < imagenum; i++) validl[0][i] = true;
	validnum = (int)((double)imagenum * 0.15);
	pos = sortlist.GetTailPosition();
	for(i = 0; i < validnum; i++) {
		if(pos == NULL) break;
		sorttemp = sortlist.GetPrev(pos);
		validl[0][sorttemp.pix] = false;
	}

	// \[g[esNZ]
	sortlist.RemoveAll();
	for(p = 0; p < PIXELNUM; p++) {
		// outlier̐𐔂
		sortunit.pix = p;
		sortunit.num = 0;
		for(i = 0; i < imagenum; i++) {
			y = p / WIDTH;
			x = p % WIDTH;
			if(valids[0][p] && validl[0][i]) {
				if(shadowopt[pixarry(i,x,y)] || specularopt[pixarry(i,x,y)]) sortunit.num++;
			}
		}
		
		// }ꏊT
		pos = sortlist.GetHeadPosition();
		while(pos != NULL) {
			sorttemp = sortlist.GetAt(pos);
			if(sortunit.num <= sorttemp.num) break;
			sortlist.GetNext(pos);
		}
		if(pos == NULL) sortlist.AddTail(sortunit);
		else sortlist.InsertBefore(pos, sortunit);
	}

	// 35%̃sNZOsNZƂĐݒ
	for(p = 0; p < PIXELNUM; p++) valids[1][p] = true;
	validnum = (int)((double)PIXELNUM * 0.35);
	pos = sortlist.GetTailPosition();
	for(p = 0; p < validnum; p++) {
		if(pos == NULL) break;
		sorttemp = sortlist.GetPrev(pos);
		valids[1][sorttemp.pix] = false;
	}

	// \[g[eCg]
	sortlist.RemoveAll();
	for(i = 0; i < imagenum; i++) {
		// outlier̐𐔂
		sortunit.pix = i;
		sortunit.num = 0;
		for(p = 0; p < PIXELNUM; p++) {
			y = p / WIDTH;
			x = p % WIDTH;
			if(valids[0][p] && validl[0][i] && valids[1][p]) {
				if(shadowopt[pixarry(i,x,y)] || specularopt[pixarry(i,x,y)]) sortunit.num++;
			}
		}
		
		// }ꏊT
		pos = sortlist.GetHeadPosition();
		while(pos != NULL) {
			sorttemp = sortlist.GetAt(pos);
			if(sortunit.num <= sorttemp.num) break;
			sortlist.GetNext(pos);
		}
		if(pos == NULL) sortlist.AddTail(sortunit);
		else sortlist.InsertBefore(pos, sortunit);
	}

	// 15%̃CgOCgƂĐݒ
	for(i = 0; i < imagenum; i++) validl[1][i] = true;
	validnum = (int)((double)imagenum * 0.15);
	pos = sortlist.GetTailPosition();
	for(i = 0; i < validnum; i++) {
		if(pos == NULL) break;
		sorttemp = sortlist.GetPrev(pos);
		validl[1][sorttemp.pix] = false;
	}

	// \[g[esNZ]
	sortlist.RemoveAll();
	for(p = 0; p < PIXELNUM; p++) {
		// outlier̐𐔂
		sortunit.pix = p;
		sortunit.num = 0;
		for(i = 0; i < imagenum; i++) {
			y = p / WIDTH;
			x = p % WIDTH;
			if(valids[0][p] && validl[0][i] && valids[1][p] && validl[1][i]) {
				if(shadowopt[pixarry(i,x,y)] || specularopt[pixarry(i,x,y)]) sortunit.num++;
			}
		}
		
		// }ꏊT
		pos = sortlist.GetHeadPosition();
		while(pos != NULL) {
			sorttemp = sortlist.GetAt(pos);
			if(sortunit.num <= sorttemp.num) break;
			sortlist.GetNext(pos);
		}
		if(pos == NULL) sortlist.AddTail(sortunit);
		else sortlist.InsertBefore(pos, sortunit);
	}

	// 15%̃sNZOsNZƂĐݒ
	for(p = 0; p < PIXELNUM; p++) valids[2][p] = true;
	validnum = (int)((double)PIXELNUM * 0.15);
	pos = sortlist.GetTailPosition();
	for(p = 0; p < validnum; p++) {
		if(pos == NULL) break;
		sorttemp = sortlist.GetPrev(pos);
		valids[2][sorttemp.pix] = false;
	}

	// \[g[eCg]
	sortlist.RemoveAll();
	for(i = 0; i < imagenum; i++) {
		// outlier̐𐔂
		sortunit.pix = i;
		sortunit.num = 0;
		for(p = 0; p < PIXELNUM; p++) {
			y = p / WIDTH;
			x = p % WIDTH;
			if(valids[0][p] && validl[0][i] && valids[1][p] && validl[1][i] && valids[2][p]) {
				if(shadowopt[pixarry(i,x,y)] || specularopt[pixarry(i,x,y)]) sortunit.num++;
			}
		}
		
		// }ꏊT
		pos = sortlist.GetHeadPosition();
		while(pos != NULL) {
			sorttemp = sortlist.GetAt(pos);
			if(sortunit.num <= sorttemp.num) break;
			sortlist.GetNext(pos);
		}
		if(pos == NULL) sortlist.AddTail(sortunit);
		else sortlist.InsertBefore(pos, sortunit);
	}

	// 35%̃CgOCgƂĐݒ
	for(i = 0; i < imagenum; i++) validl[2][i] = true;
	validnum = (int)((double)imagenum * 0.35);
	pos = sortlist.GetTailPosition();
	for(i = 0; i < validnum; i++) {
		if(pos == NULL) break;
		sorttemp = sortlist.GetPrev(pos);
		validl[2][sorttemp.pix] = false;
	}

	////////////////////////////////////////////////////////////////////////////////////////////////////
	// SVD

	for(loopsvd = LOOPSVDSTART; loopsvd >= 0; loopsvd--) {
		if(loopsvd % 2 == 0) {
			// ݂̊outlier}XNŌWvZ[lightsurface]
			for(p = 0; p < PIXELNUM; p++) {
				for(l = 0; l < 3; l++) {
					// 
					num = 0;
					for(i = 0; i < imagenum; i++) {
						y = p / WIDTH;
						x = p % WIDTH;
						if(!shadowopt[pixarry(i,x,y)] && !specularopt[pixarry(i,x,y)]) {
							tempvec[l][i] = eigenl[l][i];
							num++;
						} else tempvec[l][i] = 0.0;
					}
					val = 0.0;
					for(i = 0; i < imagenum; i++) val += tempvec[l][i] * tempvec[l][i];
					val = sqrt(val);
					if(val > EPS) {
						for(i = 0; i < imagenum; i++) tempvec[l][i] /= val;
					}
					if(num < BASISMINNUM) {
						for(i = 0; i < imagenum; i++) tempvec[l][i] = 0.0;
					}
				}
				for(l = 0; l < 3; l++) eigens[p][l] = 0.0;
				for(loopdotproduct = 0; loopdotproduct < LOOPDOTPRODUCTMAX; loopdotproduct++) {
					for(l = 0; l < 3; l++) {
						// ςvZ
						if(l == 0) {l1 = 1; l2 = 2;}
						else if(l == 1) {l1 = 0; l2 = 2;}
						else {l1 = 0; l2 = 1;}
						eigens[p][l] = 0.0;
						for(i = 0; i < imagenum; i++) {
							y = p / WIDTH;
							x = p % WIDTH;
							eigens[p][l] += tempvec[l][i] *
								((double)inputvalue(i,x,y) - eigens[p][l1] * tempvec[l1][i] - eigens[p][l2] * tempvec[l2][i]);
						}
					}
				}
				for(l = 0; l < 3; l++) {
					// ςXP[O
					denominator = 0.0;
					numerator = 0.0;
					for(i = 0; i < imagenum; i++) {
						y = p / WIDTH;
						x = p % WIDTH;
						if(!shadowopt[pixarry(i,x,y)] && !specularopt[pixarry(i,x,y)]) {
							numerator += eigenl[l][i] * tempvec[l][i];
							denominator += eigenl[l][i] * eigenl[l][i];
						}
					}
					if(denominator > EPS) val = numerator / denominator;
					else val = 0.0;
					eigens[p][l] *= val;
				}
			}
		} else {
			// ݂̊outlier}XNŌWvZ[surfacelight]
			for(i = 0; i < imagenum; i++) {
				for(l = 0; l < 3; l++) {
					// 
					num = 0;
					for(p = 0; p < PIXELNUM; p++) {
						y = p / WIDTH;
						x = p % WIDTH;
						if(!shadowopt[pixarry(i,x,y)] && !specularopt[pixarry(i,x,y)]) {
							tempvec[l][p] = eigens[p][l];
							num++;
						} else tempvec[l][p] = 0.0;
					}
					val = 0.0;
					for(p = 0; p < PIXELNUM; p++) val += tempvec[l][p] * tempvec[l][p];
					val = sqrt(val);
					if(val > EPS) {
						for(p = 0; p < PIXELNUM; p++) tempvec[l][p] /= val;
					}
					if(num < BASISMINNUM) {
						for(p = 0; p < PIXELNUM; p++) tempvec[l][p] = 0.0;
					}
				}
				for(l = 0; l < 3; l++) eigenl[l][i] = 0.0;
				for(loopdotproduct = 0; loopdotproduct < LOOPDOTPRODUCTMAX; loopdotproduct++) {
					for(l = 0; l < 3; l++) {
						// ςvZ
						if(l == 0) {l1 = 1; l2 = 2;}
						else if(l == 1) {l1 = 0; l2 = 2;}
						else {l1 = 0; l2 = 1;}
						eigenl[l][i] = 0.0;
						for(p = 0; p < PIXELNUM; p++) {
							y = p / WIDTH;
							x = p % WIDTH;
							eigenl[l][i] += tempvec[l][p] *
								((double)inputvalue(i,x,y) - eigenl[l1][i] * tempvec[l1][p] - eigenl[l2][i] * tempvec[l2][p]);
						}
					}
				}
				for(l = 0; l < 3; l++) {
					// ςXP[O
					denominator = 0.0;
					numerator = 0.0;
					for(p = 0; p < PIXELNUM; p++) {
						y = p / WIDTH;
						x = p % WIDTH;
						if(!shadowopt[pixarry(i,x,y)] && !specularopt[pixarry(i,x,y)]) {
							numerator += eigens[p][l] * tempvec[l][p];
							denominator += eigens[p][l] * eigens[p][l];
						}
					}
					if(denominator > EPS) val = numerator / denominator;
					else val = 0.0;
					eigenl[l][i] *= val;
				}
			}
		}

		// z摜vZ
		for(i = 0; i < imagenum; i++) {
			for(p = 0; p < PIXELNUM; p++) {
				y = p / WIDTH;
				x = p % WIDTH;
				val = eigens[p][0] * eigenl[0][i] + eigens[p][1] * eigenl[1][i] + eigens[p][2] * eigenl[2][i];
				idealfloat[pixarry(i,x,y)] = (float)val;
			}
		}

		// ̓f[^쐬
		for(i = 0; i < imagenum; i++) {
			for(p = 0; p < PIXELNUM; p++) {
				y = p / WIDTH;
				x = p % WIDTH;
				svdu[p][i] = (double)inputvalue(i,x,y);
				if(shadowopt[pixarry(i,x,y)] || specularopt[pixarry(i,x,y)]) svdu[p][i] = idealfloat[pixarry(i,x,y)];
			}
		}

		// f[^O
		blocknum = loopsvd / 2;
		for(k = 0; k < blocknum; k++) {
			for(i = 0; i < imagenum; i++) {
				if(!validl[k][i]) {
					for(p = 0; p < PIXELNUM; p++) {
						svdu[p][i] = 0.0;
					}
				}
			}
		}
		blocknum = (loopsvd + 1) / 2;
		for(k = 0; k < blocknum; k++) {
			for(p = 0; p < PIXELNUM; p++) {
				if(!valids[k][p]) {
					for(i = 0; i < imagenum; i++) {
						svdu[p][i] = 0.0;
					}
				}
			}
		}

		// WV
		for(i = 0; i < imagenum; i++) {
			svdw[i] = 0.0;
			for(j = 0; j < imagenum; j++) {
				svdv[i][j] = 0.0;
			}
		}

		// SVDvZ
		CalcSVD0(svdu, PIXELNUM, imagenum, svdw, svdv);

		// ْl̑傫ɂRo
		for(k = 0; k < 3; k++) {
			// ْlő̕T
			maxw = -INF;
			maxi = 0;
			for(i = 0; i < imagenum; i++) {
				if(svdw[i] >= maxw) {
					maxw = svdw[i];
					maxi = i;
				}
			}

			// ْlۑCْ̓l폜
			sval[k] = maxw;
			svdw[maxi] = 0.0;

			// USɃRs[
			for(p = 0; p < PIXELNUM; p++) eigens[p][k] = svdu[p][maxi];

			// VLɃRs[
			for(i = 0; i < imagenum; i++) eigenl[k][i] = svdv[i][maxi];
		}

		if(loopsvd % 2 == 0) {
			// gɑ΂ēْlČWƂĈ[ْllightɂ]
			for(i = 0; i < imagenum; i++) {
				eigenl[0][i] *= sval[0];
				eigenl[1][i] *= sval[1];
				eigenl[2][i] *= sval[2];
			}
		} else {
			// gɑ΂ēْlČWƂĈ[ْlsurfaceɂ]
			for(p = 0; p < PIXELNUM; p++) {
				eigens[p][0] *= sval[0];
				eigens[p][1] *= sval[1];
				eigens[p][2] *= sval[2];
			}
		}
	}

	// 
	for(p = 0; p < PIXELNUM; p++) {
		delete [] svdu[p];
	}
	for(i = 0; i < imagenum; i++) {
		delete [] svdv[i];
	}
	for(k = 0; k < LODMAXS; k++) {
		delete [] valids[k];
	}
	for(k = 0; k < LODMAXL; k++) {
		delete [] validl[k];
	}
	for(k = 0; k < 3; k++) {
		delete [] tempvec[k];
	}
	delete [] svdu;
	delete [] svdw;
	delete [] svdv;
	delete [] sval;
	delete [] valids;
	delete [] validl;
	delete [] tempvec;
}

// œKȉeo: source=non-shadow, sink=shadow
void CLayerView::CalcOptimalShadow()
{
	const float COSTNUM = 0.5f;
	const float COSTSMOOTH = 0.25f;
	const float INTENSITYMIN = 8.0f;
	const float INTENSITYMAX = 12.0f;
	int x, y;
	int img;
	int id;
	float intensityval;
	float costval;

	// Loop for each images
	for(img = 0; img < imagenum; img++) {
		// # of node  W*H
		// # of edge e (does not include t)
		//            (W-1)*H + (H-1)*W
		// ID of node i = Y*W + X
		//            i/W = Y
		//            i%W = X

		// Initialize
		graph->reset();

		// Create nodes
		graph->add_node(HEIGHT * WIDTH);

		// Data cost for source and sink
		for(y = 0; y < HEIGHT; y++) {
			for(x = 0; x < WIDTH; x++) {
				// Calculate the cost for non-shadowness
				intensityval = (float)inputvalue(img,x,y);
				if(intensityval >= INTENSITYMAX) costval = 0.0f;
				else if(intensityval <= INTENSITYMIN) costval = 1.0f;
				else costval = 1.0f - (intensityval - INTENSITYMIN) / (INTENSITYMAX - INTENSITYMIN);

				// Add cost
				id = y * WIDTH + x;
				graph->add_tweights(id, costval, COSTNUM);
			}
		}

		// Smooth cost horizontal
		for(y = 0; y < HEIGHT; y++) {
			for(x = 0; x < WIDTH - 1; x++) {
				id = y * WIDTH + x;
				graph->add_edge(id, id + 1, COSTSMOOTH, COSTSMOOTH);
			}
		}

		// Smooth cost vertical
		for(y = 0; y < HEIGHT - 1; y++) {
			for(x = 0; x < WIDTH; x++) {
				id = y * WIDTH + x;
				graph->add_edge(id, id + WIDTH, COSTSMOOTH, COSTSMOOTH);
			}
		}

		// Calculate maxflow
		graph -> maxflow();

		// Update
		for(y = 0; y < HEIGHT; y++) {
			for(x = 0; x < WIDTH; x++) {
				// Extract the result
				id = y * WIDTH + x;
				if(graph->what_segment(id) == GraphType::SOURCE) shadowopt[pixarry(img,x,y)] = true;
				else if(graph->what_segment(id) == GraphType::SINK) shadowopt[pixarry(img,x,y)] = false;
				else shadowopt[pixarry(img,x,y)] = shadowinit[pixarry(img,x,y)]; // This does not occur
			}
		}
	}
}

// œKȋʔ˂o: source=non-specular, sink=specular
void CLayerView::CalcOptimalSpecular()
{
	const float COSTNUM = 0.5f;
	const float COSTSMOOTH = 0.25f;
	const float INTENSITYMIN = 12.0f;
	const float INTENSITYMAX = 20.0f;
	int x, y;
	int img;
	int id;
	float intensityval;
	float costval;
	int i, p;
	double val;

	// zgUˉ摜vZiOȉ͂Oɂj
	for(i = 0; i < imagenum; i++) {
		for(p = 0; p < PIXELNUM; p++) {
			y = p / WIDTH;
			x = p % WIDTH;
			val = eigens[p][0] * eigenl[0][i] + eigens[p][1] * eigenl[1][i] + eigens[p][2] * eigenl[2][i];
			if(val < 0.0) val = 0.0;
			idealfloat[pixarry(i,x,y)] = (float)val;
		}
	}

	// Loop for each images
	for(img = 0; img < imagenum; img++) {
		// # of node  W*H
		// # of edge e (does not include t)
		//            (W-1)*H + (H-1)*W
		// ID of node i = Y*W + X
		//            i/W = Y
		//            i%W = X

		// Initialize
		graph->reset();

		// Create nodes
		graph->add_node(HEIGHT * WIDTH);

		// Data cost for source and sink
		for(y = 0; y < HEIGHT; y++) {
			for(x = 0; x < WIDTH; x++) {
				// Calculate the cost for non-specularness
				intensityval = (float)inputvalue(img,x,y) - idealfloat[pixarry(img,x,y)];
				if(intensityval <= INTENSITYMIN) costval = 0.0f;
				else if(intensityval >= INTENSITYMAX) costval = 1.0f;
				else costval = (intensityval - INTENSITYMIN) / (INTENSITYMAX - INTENSITYMIN);

				// Add cost
				id = y * WIDTH + x;
				graph->add_tweights(id, costval, COSTNUM);
			}
		}

		// Smooth cost horizontal
		for(y = 0; y < HEIGHT; y++) {
			for(x = 0; x < WIDTH - 1; x++) {
				id = y * WIDTH + x;
				graph->add_edge(id, id + 1, COSTSMOOTH, COSTSMOOTH);
			}
		}

		// Smooth cost vertical
		for(y = 0; y < HEIGHT - 1; y++) {
			for(x = 0; x < WIDTH; x++) {
				id = y * WIDTH + x;
				graph->add_edge(id, id + WIDTH, COSTSMOOTH, COSTSMOOTH);
			}
		}

		// Calculate maxflow
		graph -> maxflow();

		// Update
		for(y = 0; y < HEIGHT; y++) {
			for(x = 0; x < WIDTH; x++) {
				// Extract the result
				id = y * WIDTH + x;
				if(graph->what_segment(id) == GraphType::SOURCE) specularopt[pixarry(img,x,y)] = true;
				else if(graph->what_segment(id) == GraphType::SINK) specularopt[pixarry(img,x,y)] = false;
				else specularopt[pixarry(img,x,y)] = specularinit[pixarry(img,x,y)]; // This does not occur
			}
		}
	}
}

// F̈敪s
// {͓͉摜ł͂Ȃz摜gׂ
void CLayerView::OnCalcRegion()
{
	CWaitCursor wait;
	CTime ctStart;
	CTime ctEnd;
	CTimeSpan ctInterval;
	DWORD tickStart;
	DWORD tickEnd;
	DWORD tickInterval;
	CString str;
	int x, y;
	double m1, m2, m3;
	double hue, saturation, intensity;
	int loop;
	const int EROSION = 2;
	const int EXPANSION = 2;
	bool flag;
	double* medlst;
	int c;
	int i;
	double val;
	int col;
	const double HUEOFFSET = 4.0 * PI / 180.0;
	const double HUEINTERVAL = 6.0 * PI / 180.0;
	const double INTENSITYTHRESHOLD = 20.0;
	const double SATURATIONBORDER = 20.0;
	const int COUNTRYNUM = 60 + 1;
	int* country;
	int id;
	int maxid;
	int maxnum;

	// `FbN
	if(!processdone[MIYA_INPUT] || !processdone[MIYA_VALIDPIXEL]) return;

	// ̊m
	try
	{
		medlst = new double[imagenum];
		country = new int[COUNTRYNUM];
	}
	catch(...)
	{
		AfxMessageBox("܂");
		return;
	}

	// Jnݒ
	ctStart = CTime::GetCurrentTime();
	tickStart = ::GetTickCount();

	// fBA摜
	// {͗z摜ׂ͓͉摜
	for(y = 0; y < HEIGHT; y++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			for(c = 0; c < 3; c++)
			{
				for(i = 0; i < imagenum; i++)
				{
					medlst[i] = (double)inputimage[imgarry(i,x,y,c)];
				}
				val = Quarter(medlst, imagenum, 0.0, 255.0);
				col = (int)floor(val);
				if(col < 0) col = 0;
				if(col > 255) col = 255;
				medianimage[x][y][c] = (unsigned char)col;
			}
		}
	}

	// ꂼ̐F̈̉f𐔂
	for(i = 0; i < COUNTRYNUM; i++) country[i] = 0;
	for(y = 0; y < HEIGHT; y++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			if(validpixel[x][y])
			{
				m1 = (double)medianimage[x][y][COLR] - 0.5 * (double)medianimage[x][y][COLG] - 0.5 * (double)medianimage[x][y][COLB];
				m2 = sqrt(3.0) / 2.0 * ((double)medianimage[x][y][COLG] - (double)medianimage[x][y][COLB]);
				m3 = ((double)medianimage[x][y][COLR] + (double)medianimage[x][y][COLG] + (double)medianimage[x][y][COLB]) / 3.0;
				hue = atan2(m2, m1);
				if(hue < 0.0) hue += 2.0 * PI;
				saturation = NORM(m1, m2, 0.0);
				intensity = m3;
				if(intensity >= INTENSITYTHRESHOLD)
				{
					if(saturation < SATURATIONBORDER) country[COUNTRYNUM - 1]++;
					else
					{
						hue -= HUEOFFSET;
						if(hue < 0.0) hue += 2.0 * PI;
						id = (int)floor(hue / HUEINTERVAL);
						if(id < 0) id = 0;
						if(id > COUNTRYNUM - 2) id = COUNTRYNUM - 2;
						country[id]++;
					}
				}
			}
		}
	}

	// ԑ傫̈T
	maxid = COUNTRYNUM - 1;
	maxnum = 0;
	for(i = 0; i < COUNTRYNUM; i++)
	{
		if(country[i] >= maxnum)
		{
			maxnum = country[i];
			maxid = i;
		}
	}

	// ԑ傫̈I
	for(y = 0; y < HEIGHT; y++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			region[x][y] = false;
			if(validpixel[x][y])
			{
				m1 = (double)medianimage[x][y][COLR] - 0.5 * (double)medianimage[x][y][COLG] - 0.5 * (double)medianimage[x][y][COLB];
				m2 = sqrt(3.0) / 2.0 * ((double)medianimage[x][y][COLG] - (double)medianimage[x][y][COLB]);
				m3 = ((double)medianimage[x][y][COLR] + (double)medianimage[x][y][COLG] + (double)medianimage[x][y][COLB]) / 3.0;
				hue = atan2(m2, m1);
				if(hue < 0.0) hue += 2.0 * PI;
				saturation = NORM(m1, m2, 0.0);
				intensity = m3;
				if(intensity >= INTENSITYTHRESHOLD)
				{
					if(maxid == COUNTRYNUM - 1)
					{
						if(saturation < SATURATIONBORDER) region[x][y] = true;
					}
					else
					{
						if(saturation >= SATURATIONBORDER)
						{
							hue -= HUEOFFSET;
							if(hue < 0.0) hue += 2.0 * PI;
							id = (int)floor(hue / HUEINTERVAL);
							if(id < 0) id = 0;
							if(id > COUNTRYNUM - 2) id = COUNTRYNUM - 2;
							if(id == maxid) region[x][y] = true;
						}
					}
				}
			}
		}
	}

	// ZH
	for(loop = 0; loop < EROSION * 2; loop++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			for(x = loop % 2 + y % 2; x < WIDTH; x+=2)
			{
				if(region[x][y])
				{
					flag = false;
					if(x > 0)
					{
						if(!region[x-1][y]) flag = true;
					}
					if(y > 0)
					{
						if(!region[x][y-1]) flag = true;
					}
					if(x < WIDTH - 1)
					{
						if(!region[x+1][y]) flag = true;
					}
					if(y < HEIGHT - 1)
					{
						if(!region[x][y+1]) flag = true;
					}
					if(flag) region[x][y] = false;
				}
			}
		}
	}

	// c
	for(loop = 0; loop < EXPANSION * 2; loop++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			for(x = loop % 2 + y % 2; x < WIDTH; x+=2)
			{
				if(!region[x][y])
				{
					flag = false;
					if(x > 0)
					{
						if(region[x-1][y]) flag = true;
					}
					if(y > 0)
					{
						if(region[x][y-1]) flag = true;
					}
					if(x < WIDTH - 1)
					{
						if(region[x+1][y]) flag = true;
					}
					if(y < HEIGHT - 1)
					{
						if(region[x][y+1]) flag = true;
					}
					if(flag) region[x][y] = true;
				}
			}
		}
	}

	// IbZ[W
	ctEnd = CTime::GetCurrentTime();
	ctInterval = ctEnd - ctStart;
	tickEnd = ::GetTickCount();
	tickInterval = tickEnd - tickStart;
	str = "vZI܂\n";
	str += "\n";
	str += "Jn: " + ctStart.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "I: " + ctEnd.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "oߎ: " + ctInterval.Format("%H:%M:%S") + "\n";
	str.AppendFormat("oߎ: %dm~bn\n",  tickInterval);

	// ̉
	delete [] medlst;
	delete [] country;

	// ㏈
	processdone[MIYA_MEDIAN] = true;
	processdone[MIYA_REGION] = true;
	viewmode = MIYA_REGION;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
	AfxMessageBox(str);
}

// Axh
void CLayerView::OnCalcConstraint()
{
	CWaitCursor wait;
	CTime ctStart;
	CTime ctEnd;
	CTimeSpan ctInterval;
	DWORD tickStart;
	DWORD tickEnd;
	DWORD tickInterval;
	CString str;
	CString str2;
	int x, y;
	int i;
	int p;
	double** svdu;
	double* svdw;
	double** svdv;
	double nx, ny, nz;
	double r;
	double* matb;
	int j;
	double det;
	double val;
	int svdnum;

	// `FbN
	if(!processdone[MIYA_REGION] || !processdone[MIYA_BASIS1]) return;

	// ̊m
	try
	{
		svdu = new double*[PIXELNUM + 1];
		svdw = new double[6 + 1];
		svdv = new double*[6 + 1];
		matb = new double[6];
	}
	catch(...)
	{
		AfxMessageBox("܂");
		return;
	}
	for(i = 1; i <= PIXELNUM; i++)
	{
		try
		{
			svdu[i] = new double[6 + 1];
		}
		catch(...)
		{
			AfxMessageBox("܂");
			return;
		}
	}
	for(i = 1; i <= 6; i++)
	{
		try
		{
			svdv[i] = new double[6 + 1];
		}
		catch(...)
		{
			AfxMessageBox("܂");
			return;
		}
	}

	// Jnݒ
	ctStart = CTime::GetCurrentTime();
	tickStart = ::GetTickCount();

	// vZɎgfI
	i = 1;
	for(y = 0; y < HEIGHT; y++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			if(region[x][y])
			{
				// SVD̂߂̏ݒ
				// Numerical Recipes͔z̓Y1n܂
				j = y * WIDTH + x;
				svdu[i][1] = eigens[j][0] * eigens[j][0];
				svdu[i][2] = eigens[j][1] * eigens[j][1];
				svdu[i][3] = eigens[j][2] * eigens[j][2];
				svdu[i][4] = 2.0 * eigens[j][0] * eigens[j][1];
				svdu[i][5] = 2.0 * eigens[j][1] * eigens[j][2];
				svdu[i][6] = 2.0 * eigens[j][2] * eigens[j][0];
				i++;
			}
		}
	}
	svdnum = i - 1;

	// WV
	for(i = 1; i <= 6; i++)
	{
		svdw[i] = 0.0;
		for(j = 1; j <= 6; j++)
		{
			svdv[i][j] = 0.0;
		}
	}

	// SVDvZ
	CalcSVD1(svdu, svdnum, 6, svdw, svdv);

	// ْltɂ
	str2 = "ْl\n";
	for(i = 1; i <= 6; i++)
	{
		str2.AppendFormat("%f\n", svdw[i]);
		svdw[i] = 1.0 / svdw[i];
	}

	// W^-1 * U^T * (1,...,1) vZsvdwɓD̓xNg
	for(j = 1; j <= 6; j++)
	{
		val = 0.0;
		for(i = 1; i <= svdnum; i++)
		{
			val += svdu[i][j];
		}
		svdw[j] *= val;
	}

	// V * (W^-1 * U^T * (1,...,1)) vZmatbɓDꂪB
	for(j = 1; j <= 6; j++)
	{
		val = 0.0;
		for(i = 1; i <= 6; i++)
		{
			val += svdv[j][i] * svdw[i];
		}
		matb[j - 1] = val;
	}

	// 
	for(i = 1; i <= PIXELNUM; i++)
	{
		delete [] svdu[i];
	}
	delete [] svdu;
	delete [] svdw;
	for(i = 1; i <= 6; i++)
	{
		delete [] svdv[i];
	}
	delete [] svdv;

	// m
	try
	{
		svdu = new double*[3 + 1];
		svdw = new double[3 + 1];
		svdv = new double*[3 + 1];
	}
	catch(...)
	{
		AfxMessageBox("܂");
		return;
	}
	for(i = 1; i <= 3; i++)
	{
		try
		{
			svdu[i] = new double[3 + 1];
			svdv[i] = new double[3 + 1];
		}
		catch(...)
		{
			AfxMessageBox("܂");
			return;
		}
	}

	// SVD̂߂̏ݒ
	// Numerical Recipes͔z̓Y1n܂
	// R~RsBRs[
	svdu[1][1] = matb[0];
	svdu[2][2] = matb[1];
	svdu[3][3] = matb[2];
	svdu[1][2] = svdu[2][1] = matb[3];
	svdu[2][3] = svdu[3][2] = matb[4];
	svdu[3][1] = svdu[1][3] = matb[5];

	// WV
	for(i = 1; i <= 3; i++)
	{
		svdw[i] = 0.0;
		for(j = 1; j <= 3; j++)
		{
			svdv[i][j] = 0.0;
		}
	}

	// SVDvZ
	CalcSVD1(svdu, 3, 3, svdw, svdv);

	// ْl[gɂ
	for(i = 1; i <= 3; i++)
	{
		svdw[i] = sqrt(svdw[i]);
	}

	// U~WvZsvduɓDꂪAɂȂ
	svdu[1][1] *= svdw[1];
	svdu[1][2] *= svdw[2];
	svdu[1][3] *= svdw[3];
	svdu[2][1] *= svdw[1];
	svdu[2][2] *= svdw[2];
	svdu[2][3] *= svdw[3];
	svdu[3][1] *= svdw[1];
	svdu[3][2] *= svdw[2];
	svdu[3][3] *= svdw[3];

	// S*AVSɂ
	for(p = 0; p < PIXELNUM; p++)
	{
		conss[p][0] = eigens[p][0] * svdu[1][1] + eigens[p][1] * svdu[2][1] + eigens[p][2] * svdu[3][1];
		conss[p][1] = eigens[p][0] * svdu[1][2] + eigens[p][1] * svdu[2][2] + eigens[p][2] * svdu[3][2];
		conss[p][2] = eigens[p][0] * svdu[1][3] + eigens[p][1] * svdu[2][3] + eigens[p][2] * svdu[3][3];
	}

	// A̋tsvZsvdvɓ
	det =
		svdu[1][1] * svdu[2][2] * svdu[3][3] +
		svdu[2][1] * svdu[3][2] * svdu[1][3] +
		svdu[3][1] * svdu[1][2] * svdu[2][3] -
		svdu[1][1] * svdu[3][2] * svdu[2][3] -
		svdu[3][1] * svdu[2][2] * svdu[1][3] -
		svdu[2][1] * svdu[1][2] * svdu[3][3];
	if(fabs(det) < EPS)
	{
		AfxMessageBox("f[^ł");
		return;
	}
	svdv[1][1] = svdu[2][2] * svdu[3][3] - svdu[2][3] * svdu[3][2];
	svdv[1][2] = svdu[1][3] * svdu[3][2] - svdu[1][2] * svdu[3][3];
	svdv[1][3] = svdu[1][2] * svdu[2][3] - svdu[1][3] * svdu[2][2];
	svdv[2][1] = svdu[2][3] * svdu[3][1] - svdu[2][1] * svdu[3][3];
	svdv[2][2] = svdu[1][1] * svdu[3][3] - svdu[1][3] * svdu[3][1];
	svdv[2][3] = svdu[1][3] * svdu[2][1] - svdu[1][1] * svdu[2][3];
	svdv[3][1] = svdu[2][1] * svdu[3][2] - svdu[2][2] * svdu[3][1];
	svdv[3][2] = svdu[1][2] * svdu[3][1] - svdu[1][1] * svdu[3][2];
	svdv[3][3] = svdu[1][1] * svdu[2][2] - svdu[1][2] * svdu[2][1];
	svdv[1][1] /= det;
	svdv[1][2] /= det;
	svdv[1][3] /= det;
	svdv[2][1] /= det;
	svdv[2][2] /= det;
	svdv[2][3] /= det;
	svdv[3][1] /= det;
	svdv[3][2] /= det;
	svdv[3][3] /= det;

	// A.inv*LVLɂ
	for(i = 0; i < imagenum; i++)
	{
		consl[0][i] = svdv[1][1] * eigenl[0][i] + svdv[1][2] * eigenl[1][i] + svdv[1][3] * eigenl[2][i];
		consl[1][i] = svdv[2][1] * eigenl[0][i] + svdv[2][2] * eigenl[1][i] + svdv[2][3] * eigenl[2][i];
		consl[2][i] = svdv[3][1] * eigenl[0][i] + svdv[3][2] * eigenl[1][i] + svdv[3][3] * eigenl[2][i];
	}

	// \ʍs񂩂@ƃAxho
	for(p = 0; p < PIXELNUM; p++)
	{
		x = p % WIDTH;
		y = p / WIDTH;
		nx = conss[p][AXISX];
		ny = conss[p][AXISY];
		nz = conss[p][AXISZ];
		r = NORM(nx, ny, nz);
		if(r > EPS)
		{
			nx /= r;
			ny /= r;
			nz /= r;
		}
		else
		{
			nx = 0.0;
			ny = 0.0;
			nz = 1.0;
		}
		normalconstraint[x][y][AXISX] = nx;
		normalconstraint[x][y][AXISY] = ny;
		normalconstraint[x][y][AXISZ] = nz;
		albedo[x][y][COLR] = r; // ݂̏CR`l݂̂gp
		albedo[x][y][COLG] = 0;
		albedo[x][y][COLB] = 0;
	}

	// IbZ[W
	ctEnd = CTime::GetCurrentTime();
	ctInterval = ctEnd - ctStart;
	tickEnd = ::GetTickCount();
	tickInterval = tickEnd - tickStart;
	str = "vZI܂\n";
	str += "\n";
	str += "Jn: " + ctStart.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "I: " + ctEnd.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "oߎ: " + ctInterval.Format("%H:%M:%S") + "\n";
	str.AppendFormat("oߎ: %dm~bn\n",  tickInterval);
	str = str + "\n" + str2;

	// 
	for(p = 1; p <= 3; p++)
	{
		delete [] svdu[p];
	}
	delete [] svdu;
	delete [] svdw;
	for(i = 1; i <= 3; i++)
	{
		delete [] svdv[i];
	}
	delete [] svdv;

	// ㏈
	processdone[MIYA_ALBEDO] = true;
	processdone[MIYA_ZENITHCONSTRAINT] = true;
	processdone[MIYA_AZIMUTHCONSTRAINT] = true;
	processdone[MIYA_NEEDLECONSTRAINT] = true;
	viewmode = MIYA_ALBEDO;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
	AfxMessageBox(str);
}

// ՕEvZ
// {͓͉摜ł͂Ȃz摜gׂ
void CLayerView::OnCalcBoundary()
{
	CWaitCursor wait;
	CTime ctStart;
	CTime ctEnd;
	CTimeSpan ctInterval;
	DWORD tickStart;
	DWORD tickEnd;
	DWORD tickInterval;
	CString str;
	int x, y;
	int i;
	const unsigned char INTENSITYTHRESHOLD = 10;
	int j;
	bool ischanged;
	int loop;
	const int THICKNESS = 4;
	double nx, ny, nz;
	double dx, dy;
	int xx, yy;
	const int BOUNDARYWINDOW = 7;
	double length;
	const double OFFSETZ = 0.01;
	unsigned char intensval;
	const int EROSION = 2;
	const int EXPANSION = 2;
	bool flag;

	// `FbN
	if(!processdone[MIYA_INPUT] || !processdone[MIYA_REGION]) return;

	// Jnݒ
	ctStart = CTime::GetCurrentTime();
	tickStart = ::GetTickCount();

	// ݒ
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			inside[x][y] = REGIONINSIDE;
		}
	}

	// Sӂ͕̂̊OƂ
	for(x = 0; x < WIDTH; x++) inside[x][0] = inside[x][HEIGHT - 1] = REGIONOUTSIDE;
	for(y = 0; y < HEIGHT; y++) inside[0][y] = inside[WIDTH - 1][y] = REGIONOUTSIDE;

	// ̗̈vZ
	for(;;)
	{
		ischanged = false;
		for(i = 0; i < 2; i++)
		{
			j = i;
			for(y = 1; y < HEIGHT - 1; y++)
			{
				j = (j + 1) % 2;
				for(x = 1 + j; x < WIDTH - 1; x += 2)
				{
					if(inside[x][y] == REGIONINSIDE)
					{
						if(inside[x-1][y] == REGIONOUTSIDE || inside[x+1][y] == REGIONOUTSIDE ||
							inside[x][y-1] == REGIONOUTSIDE || inside[x][y+1] == REGIONOUTSIDE)
						{
							intensval = (medianimage[x][y][COLR] + medianimage[x][y][COLG] + medianimage[x][y][COLB]) / 3;
							if(intensval < INTENSITYTHRESHOLD)
							{
								inside[x][y] = REGIONOUTSIDE;
								ischanged = true;
							}
						}
					}
				}
			}
		}
		if(ischanged == false) break;
	}

	// ZH
	for(loop = 0; loop < EROSION * 2; loop++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			for(x = loop % 2 + y % 2; x < WIDTH; x+=2)
			{
				if(inside[x][y])
				{
					flag = false;
					if(x > 0)
					{
						if(!inside[x-1][y]) flag = true;
					}
					if(y > 0)
					{
						if(!inside[x][y-1]) flag = true;
					}
					if(x < WIDTH - 1)
					{
						if(!inside[x+1][y]) flag = true;
					}
					if(y < HEIGHT - 1)
					{
						if(!inside[x][y+1]) flag = true;
					}
					if(flag) inside[x][y] = false;
				}
			}
		}
	}

	// c
	for(loop = 0; loop < EXPANSION * 2; loop++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			for(x = loop % 2 + y % 2; x < WIDTH; x+=2)
			{
				if(!inside[x][y])
				{
					flag = false;
					if(x > 0)
					{
						if(inside[x-1][y]) flag = true;
					}
					if(y > 0)
					{
						if(inside[x][y-1]) flag = true;
					}
					if(x < WIDTH - 1)
					{
						if(inside[x+1][y]) flag = true;
					}
					if(y < HEIGHT - 1)
					{
						if(inside[x][y+1]) flag = true;
					}
					if(flag) inside[x][y] = true;
				}
			}
		}
	}

	// ՕEo
	for(x = 1; x < WIDTH - 1; x++)
	{
		for(y = 1; y < HEIGHT - 1; y++)
		{
			if(inside[x][y] == REGIONINSIDE)
			{
				if(inside[x-1][y] == REGIONOUTSIDE || inside[x+1][y] == REGIONOUTSIDE ||
					inside[x][y-1] == REGIONOUTSIDE || inside[x][y+1] == REGIONOUTSIDE) inside[x][y] = REGIONBOUNDARY;
			}
		}
	}

	// ՕE𑾂
	for(loop = 0; loop < THICKNESS; loop++)
	{
		for(i = 0; i < 2; i++)
		{
			j = i;
			for(y = 1; y < HEIGHT - 1; y++)
			{
				j = (j + 1) % 2;
				for(x = 1 + j; x < WIDTH - 1; x += 2)
				{
					if(inside[x][y] == REGIONINSIDE)
					{
						if(inside[x-1][y] == REGIONBOUNDARY || inside[x+1][y] == REGIONBOUNDARY ||
							inside[x][y-1] == REGIONBOUNDARY || inside[x][y+1] == REGIONBOUNDARY)
						{
							inside[x][y] = REGIONBOUNDARY;
						}
					}
				}
			}
		}
	}

	// Eł̖@vZ
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			if(inside[x][y] == REGIONBOUNDARY)
			{
				nx = 0.0;
				ny = 0.0;
				for(xx = x - BOUNDARYWINDOW; xx <= x + BOUNDARYWINDOW; xx++)
				{
					for(yy = y - BOUNDARYWINDOW; yy <= y + BOUNDARYWINDOW; yy++)
					{
						if(xx >= 0 && xx < WIDTH && yy >= 0 && yy < HEIGHT)
						{
							if(!(xx == x && yy == y))
							{
								dx = (double)(xx - x);
								dy = (double)(yy - y);
								length = NORM(dx, dy, 0.0);
								dx /= length;
								dy /= length;
								if(inside[xx][yy] == REGIONOUTSIDE)
								{
									nx += dx;
									ny += dy;
								}
								if(inside[xx][yy] == REGIONINSIDE || inside[xx][yy] == REGIONBOUNDARY)
								{
									nx += -dx;
									ny += -dy;
								}
							}
						}
					}
				}
				length = NORM(nx, ny, 0.0);
				if(length > EPS)
				{
					nx /= length;
					ny /= length;
					nz = 0.0;
				}
				else
				{
					nx = 0.0;
					ny = 0.0;
					nz = 1.0;
				}
			}
			else
			{
				nx = 0.0;
				ny = 0.0;
				nz = 1.0;
			}
			nz += OFFSETZ;
			length = NORM(nx, ny, nz);
			nx /= length;
			ny /= length;
			nz /= length;
			normalboundary[x][y][AXISX] = nx;
			normalboundary[x][y][AXISY] = ny;
			normalboundary[x][y][AXISZ] = nz;
		}
	}

	// IbZ[W
	ctEnd = CTime::GetCurrentTime();
	ctInterval = ctEnd - ctStart;
	tickEnd = ::GetTickCount();
	tickInterval = tickEnd - tickStart;
	str = "vZI܂\n";
	str += "\n";
	str += "Jn: " + ctStart.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "I: " + ctEnd.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "oߎ: " + ctInterval.Format("%H:%M:%S") + "\n";
	str.AppendFormat("oߎ: %dm~bn\n",  tickInterval);

	// ㏈
	processdone[MIYA_INSIDE] = true;
	processdone[MIYA_ZENITHBOUNDARY] = true;
	processdone[MIYA_AZIMUTHBOUNDARY] = true;
	processdone[MIYA_NEEDLEBOUNDARY] = true;
	viewmode = MIYA_INSIDE;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
	AfxMessageBox(str);
}

// ]s̞B
void CLayerView::OnCalcRotation()
{
	CWaitCursor wait;
	CTime ctStart;
	CTime ctEnd;
	CTimeSpan ctInterval;
	DWORD tickStart;
	DWORD tickEnd;
	DWORD tickInterval;
	CString str;
	CString str2;
	int x, y;
	int i;
	double** svdu;
	double* svdw;
	double** svdv;
	int j;
	CList<CPoint, CPoint&> boundary;
	POSITION pos;
	CPoint point;
	double utemp1, utemp2, utemp3;
	double* rx;
	double* ry;
	double* rz;
	double d;
	double svdx, svdy, svdz;
	double rotx, roty, rotz;

	// `FbN
	if(!processdone[MIYA_NEEDLECONSTRAINT] || !processdone[MIYA_INSIDE]) return;

	// Jnݒ
	ctStart = CTime::GetCurrentTime();
	tickStart = ::GetTickCount();

	// occluding boundaryXgAbv
	boundary.RemoveAll();
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			if(inside[x][y] == REGIONBOUNDARY)
			{
				boundary.AddTail(CPoint(x, y));
			}
		}
	}

	// ̊m
	try
	{
		svdu = new double*[boundary.GetCount() + 1];
		svdw = new double[3 + 1];
		svdv = new double*[3 + 1];
		rx = new double[3];
		ry = new double[3];
		rz = new double[3];
	}
	catch(...)
	{
		AfxMessageBox("܂");
		return;
	}
	for(i = 1; i <= boundary.GetCount(); i++)
	{
		try
		{
			svdu[i] = new double[3 + 1];
		}
		catch(...)
		{
			AfxMessageBox("܂");
			return;
		}
	}
	for(i = 1; i <= 3; i++)
	{
		try
		{
			svdv[i] = new double[3 + 1];
		}
		catch(...)
		{
			AfxMessageBox("܂");
			return;
		}
	}

	// SVD̂߂̏ݒ
	// Numerical Recipes͔z̓Y1n܂
	pos = boundary.GetHeadPosition();
	for(i = 1; i <= boundary.GetCount(); i++)
	{
		point = boundary.GetNext(pos);
		x = point.x;
		y = point.y;
		svdu[i][1] = normalconstraint[x][y][AXISX];
		svdu[i][2] = normalconstraint[x][y][AXISY];
		svdu[i][3] = normalconstraint[x][y][AXISZ];
	}

	// WV
	for(i = 1; i <= 3; i++)
	{
		svdw[i] = 0.0;
		for(j = 1; j <= 3; j++)
		{
			svdv[i][j] = 0.0;
		}
	}

	// SVDvZ
	CalcSVD1(svdu, (int)boundary.GetCount(), 3, svdw, svdv);
	str2 = "ْl: ";
	str2.AppendFormat("%.2f, %.2f, %.2f\n", svdw[1], svdw[2], svdw[3]);

	// ْl̋tvZ
	svdw[1] = 1.0 / svdw[1];
	svdw[2] = 1.0 / svdw[2];
	svdw[3] = 1.0 / svdw[3];

	// VWvZCsvdvɊi[
	svdv[1][1] *= svdw[1];
	svdv[1][2] *= svdw[2];
	svdv[1][3] *= svdw[3];
	svdv[2][1] *= svdw[1];
	svdv[2][2] *= svdw[2];
	svdv[2][3] *= svdw[3];
	svdv[3][1] *= svdw[1];
	svdv[3][2] *= svdw[2];
	svdv[3][3] *= svdw[3];

	// VWU^TvZCsvduɊi[
	for(i = 1; i <= boundary.GetCount(); i++)
	{
		utemp1 = svdu[i][1];
		utemp2 = svdu[i][2];
		utemp3 = svdu[i][3];
		svdu[i][1] = svdv[1][1] * utemp1 + svdv[1][2] * utemp2 + svdv[1][3] * utemp3;
		svdu[i][2] = svdv[2][1] * utemp1 + svdv[2][2] * utemp2 + svdv[2][3] * utemp3;
		svdu[i][3] = svdv[3][1] * utemp1 + svdv[3][2] * utemp2 + svdv[3][3] * utemp3;
	}

	// ՕE̖@g]s̃xNgvZ
	rx[0] = rx[1] = rx[2] = 0.0;
	ry[0] = ry[1] = ry[2] = 0.0;
	rz[0] = rz[1] = rz[2] = 0.0;
	pos = boundary.GetHeadPosition();
	for(i = 1; i <= boundary.GetCount(); i++)
	{
		point = boundary.GetNext(pos);
		x = point.x;
		y = point.y;
		rx[0] += svdu[i][1] * normalboundary[x][y][AXISX];
		rx[1] += svdu[i][2] * normalboundary[x][y][AXISX];
		rx[2] += svdu[i][3] * normalboundary[x][y][AXISX];
		ry[0] += svdu[i][1] * normalboundary[x][y][AXISY];
		ry[1] += svdu[i][2] * normalboundary[x][y][AXISY];
		ry[2] += svdu[i][3] * normalboundary[x][y][AXISY];
		rz[0] += svdu[i][1] * normalboundary[x][y][AXISZ];
		rz[1] += svdu[i][2] * normalboundary[x][y][AXISZ];
		rz[2] += svdu[i][3] * normalboundary[x][y][AXISZ];
	}
	str2 += "]s̃xNg: ";
	str2.AppendFormat("[%.2f, %.2f, %.2f], ", rx[0], rx[1], rx[2]);
	str2.AppendFormat("[%.2f, %.2f, %.2f], ", ry[0], ry[1], ry[2]);
	str2.AppendFormat("[%.2f, %.2f, %.2f]\n", rz[0], rz[1], rz[2]);

	// ]xNgX
	d = NORM(rx[0], rx[1], rx[2]);
	if(d > EPS)
	{
		rx[0] /= d;
		rx[1] /= d;
		rx[2] /= d;
	}
	else
	{
		// ^ǂ΂ł
	}

	// ]xNgY
	d = NORM(ry[0], ry[1], ry[2]);
	if(d > EPS)
	{
		ry[0] /= d;
		ry[1] /= d;
		ry[2] /= d;
	}
	else
	{
		// ^ǂ΂ł
	}

	// ]xNgZ
	d = NORM(rz[0], rz[1], rz[2]);
	if(d > EPS)
	{
		rz[0] /= d;
		rz[1] /= d;
		rz[2] /= d;
	}
	else
	{
		// ^ǂ΂ł
	}

	// ]s𒼌
	CalcOrthogonal(rx, ry, rz);
	str2 += "̉]s: ";
	str2.AppendFormat("[%.2f, %.2f, %.2f], ", rx[0], rx[1], rx[2]);
	str2.AppendFormat("[%.2f, %.2f, %.2f], ", ry[0], ry[1], ry[2]);
	str2.AppendFormat("[%.2f, %.2f, %.2f]\n", rz[0], rz[1], rz[2]);

	// @]
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			svdx = normalconstraint[x][y][AXISX];
			svdy = normalconstraint[x][y][AXISY];
			svdz = normalconstraint[x][y][AXISZ];
			rotx = rx[0] * svdx + rx[1] * svdy + rx[2] * svdz;
			roty = ry[0] * svdx + ry[1] * svdy + ry[2] * svdz;
			rotz = rz[0] * svdx + rz[1] * svdy + rz[2] * svdz;
			coordnormal[x][y][AXISX] = rotx;
			coordnormal[x][y][AXISY] = roty;
			coordnormal[x][y][AXISZ] = rotz;
		}
	}

	// ]
	for(i = 0; i < imagenum; i++)
	{
		svdx = consl[0][i];
		svdy = consl[1][i];
		svdz = consl[2][i];
		rotx = rx[0] * svdx + rx[1] * svdy + rx[2] * svdz;
		roty = ry[0] * svdx + ry[1] * svdy + ry[2] * svdz;
		rotz = rz[0] * svdx + rz[1] * svdy + rz[2] * svdz;
		coordl[0][i] = rotx;
		coordl[1][i] = roty;
		coordl[2][i] = rotz;
	}

	// 
	for(i = 1; i <= 3; i++)
	{
		delete [] svdv[i];
	}
	delete [] svdv;
	delete [] svdw;
	for(i = 1; i <= boundary.GetCount(); i++)
	{
		delete [] svdu[i];
	}
	delete [] svdu;
	delete [] rx;
	delete [] ry;
	delete [] rz;

	// IbZ[W
	ctEnd = CTime::GetCurrentTime();
	ctInterval = ctEnd - ctStart;
	tickEnd = ::GetTickCount();
	tickInterval = tickEnd - tickStart;
	str = "vZI܂\n";
	str += "\n";
	str += "Jn: " + ctStart.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "I: " + ctEnd.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "oߎ: " + ctInterval.Format("%H:%M:%S") + "\n";
	str.AppendFormat("oߎ: %dm~bn\n",  tickInterval);
	str = str + "\n" + str2;

	// ㏈
	processdone[MIYA_COORDZENITH] = true;
	processdone[MIYA_COORDAZIMUTH] = true;
	processdone[MIYA_COORDNEEDLE] = true;
	viewmode = MIYA_COORDAZIMUTH;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
	AfxMessageBox(str);
}

// AxhvZ
void CLayerView::OnCalcTricolor()
{
	CWaitCursor wait;
	int x, y;
	int i;
	double w;
	CTime ctStart;
	CTime ctEnd;
	CTimeSpan ctInterval;
	DWORD tickStart;
	DWORD tickEnd;
	DWORD tickInterval;
	CString str;
	const double SHADINGMIN = 0.01;
	double rval, gval, bval;
	double shadingval;
	double** light;
	double scale;
	int ir, ig, ib;

	// `FbN
	if(!processdone[MIYA_COORDNEEDLE]) return;

	// m
	light = NULL;
	light = new double*[imagenum];
	if(light == NULL) {
		AfxMessageBox("܂");
		return;
	}
	for(i = 0; i < imagenum; i++) {
		light[i] = NULL;
		light[i] = new double[3];
		if(light[i] == NULL) {
			AfxMessageBox("܂");
			return;
		}
	}

	// Jnݒ
	ctStart = CTime::GetCurrentTime();
	tickStart = ::GetTickCount();

	// Px܂ތXgAbv
	scale = 0.0;
	for(i = 0; i < imagenum; i++) {
		light[i][AXISX] = coordl[0][i];
		light[i][AXISY] = coordl[1][i];
		light[i][AXISZ] = coordl[2][i];
		scale += NORM(light[i][AXISX], light[i][AXISY], light[i][AXISZ]);
	}
	scale /= (double)imagenum;

	// Px𕽋ςPɂ
	if(scale > EPS) {
		for(i = 0; i < imagenum; i++) {
			light[i][AXISX] /= scale;
			light[i][AXISY] /= scale;
			light[i][AXISZ] /= scale;
		}
	}

	// ŏ@Ŗ@߂
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			// Axh̐ldݕtŉZ
			rval = gval = bval = 0.0;
			w = 0.0;
			for(i = 0; i < imagenum; i++) {
				shadingval = DOTPRODUCT(coordnormal[x][y][AXISX], coordnormal[x][y][AXISY], coordnormal[x][y][AXISZ], light[i][AXISX], light[i][AXISY], light[i][AXISZ]);
				if(!shadowopt[pixarry(i,x,y)] && !specularopt[pixarry(i,x,y)] && shadingval > SHADINGMIN) {
					rval += (double)inputimage[imgarry(i,x,y,COLR)]; // Axh͓͋PxVF[fBOCVF[fBO̒ld݂ƂāCdݕtavZ
					gval += (double)inputimage[imgarry(i,x,y,COLG)];
					bval += (double)inputimage[imgarry(i,x,y,COLB)];
					w += shadingval;
				}
			}
			if(w > EPS) {
				rval /= w;
				gval /= w;
				bval /= w;
			}
			ir = (int)floor(rval + 0.5);
			ig = (int)floor(gval + 0.5);
			ib = (int)floor(bval + 0.5);
			if(ir < 0) ir = 0;
			if(ig < 0) ig = 0;
			if(ib < 0) ib = 0;
			if(ir > 255) ir = 255;
			if(ig > 255) ig = 255;
			if(ib > 255) ib = 255;
			tricolor[imgarry(x,y,COLR)] = (unsigned char)ir;
			tricolor[imgarry(x,y,COLG)] = (unsigned char)ig;
			tricolor[imgarry(x,y,COLB)] = (unsigned char)ib;
		}
	}

	// Iݒ
	ctEnd = CTime::GetCurrentTime();
	tickEnd = ::GetTickCount();

	// 
	for(i = 0; i < imagenum; i++) {
		delete [] light[i];
	}
	delete [] light;

	// ㏈
	processdone[MIYA_TRICOLOR] = true;
	viewmode = MIYA_TRICOLOR;
	CheckView(viewmode);
	CreateImages();
	Invalidate();

	// IbZ[W
	str = "vZI܂\n";
	str += "\n";
	str += "Jn: " + ctStart.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "I: " + ctEnd.Format("%Y/%m/%d %H:%M:%S") + "\n";
	ctInterval = ctEnd - ctStart;
	str += "vZ: " + ctInterval.Format("%H:%M:%S") + "\n";
	tickInterval = tickEnd - tickStart;
	str.AppendFormat("vZ: %dm~bn\n",  tickInterval);
	AfxMessageBox(str);
}
